<TeXmacs|1.0.6>

<style|generic>

<\body>
  <section|Conversion>

  Since the converting from a type to another is a very frequent operation,
  whcih can be used explicitly or implicitly, we consider it with a special
  care. A namespace <samp|let> is used to do these explicit conversion from
  one type to the other. Two functions are available in this namespace:

  <\itemize-dot>
    <item><verbatim|void let::assign(X & x, const Y & y)> which assign the
    variable <samp|x> to a value <samp|y>,

    <item><verbatim|Y let::convert(const X& x,type::As\<less\>Y\<gtr\>())>,
    which return a value of type <samp|Y>, from a value of type <samp|X>. The
    empty class <verbatim|type::As\<less\>Y\<gtr\>> is used to specify the
    output type.\ 
  </itemize-dot>

  In order to extend the existing set of conversions, one has to define the
  missing functions in the namespace <verbatim|let> or in the namespace of
  the data.

  <\quote-env>
    <\code>
      namespace let {

      \ \ \ \ void assign(X0 & x, const Y0 & y) { ... }

      }
    </code>
  </quote-env>

  If no specialization of <verbatim|let::assign(X& x, const Y&y)> for given
  types <verbatim|X>, <verbatim|Y> is available the operator <verbatim|=>
  will be used: <verbatim|x=y;>

  <subsection|Example>

  In order to apply the default convertions, \ the following include
  directive should be used:

  <\quote-env>
    <\code>
      #include \<less\>synaps/arithm/let.h\<gtr\>
    </code>
  </quote-env>

  Here is an example of convertion from a string to an <verbatim|int> and a
  <verbatim|double> type:

  <\code>
    \ \ int i; \ \ \ let::assign(i, "23432432");

    \ \ double d; let::assign(d,"4343.43234");
  </code>

  <subsection|Implementation>

  See: <verbatim|synaps/arithm/let.h>.
</body>

<\initial>
  <\collection>
    <associate|language|french>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Conversion>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>
    </associate>
  </collection>
</auxiliary>