/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
History:
$Id: AlgClos.h,v 1.1 2005/07/11 10:39:47 mourrain Exp $
**********************************************************************/
#ifndef SYNAPS_ARITHM_ALGCLOS_H
#define SYNAPS_ARITHM_ALGCLOS_H

#include <synaps/init.h>

namespace std
{
  template<class C> struct complex;
}

__BEGIN_NAMESPACE_SYNAPS

/**
This class is a traits class used to specify the type corresponding
to the algebraic closure. The complex type for a class @T@ is
@AlgClos<T>::TYPE@.
By default the algebraic closure class of @T@ is @std::complex<T>@.
We have the following specialisation:

\arg  @AlgClos<std::complex<T> >::TYPE=std:complex<T>@ for any @T@.
**/
template <class T> struct AlgClos {
  typedef std::complex<T> TYPE;
};

template<class T> struct AlgClos<std::complex<T> > {
  typedef std::complex<T> TYPE;
};

__END_NAMESPACE_SYNAPS
#endif // SYNAPS_ARITHM_ALGCLOS_H
