
#ifndef SYNAPS_ARITHM_FD_H
#define SYNAPS_ARITHM_FD_H

#include <synaps/init.h>
#include <synaps/arithm/Rg.h>

__BEGIN_NAMESPACE_SYNAPS

template<class T>
struct Fd : public Rg<T>
{
  Fd () :Rg() {}
  Fd (const Fd<T>& b) : Rg<T>(b)   {}
  Fd (const T& t): Rg<T>(t)        {}
  Fd (int si): Rg<T>(si)           {}
  Fd (signed long sl): Rg<T>(sl)   {}
  Fd (unsigned long ul): Rg<T>(ul) {}
  Fd (const char* str, unsigned int b=10): Rg<T>(str,b) {}
  Fd (double d)                    {init_set(rep(),d);}

  ~Fd () {};//clear(rep()); }

}


__END_NAMESPACE_SYNAPS


#endif // SYNAPS_ARITHM_FD_H

