#ifndef SYNAPS_ARITHM_NORM_H
#define SYNAPS_ARITHM_NORM_H

#include <complex>
#include <synaps/init.h>
//#include <synaps/numerics/Double.h>

__BEGIN_NAMESPACE_SYNAPS

inline float  Norm(float  s) {return std::fabs(s);}
inline double Norm(double s) {return std::fabs(s);}

template<class R> unsigned size(const R & x) {return x.size();}
inline float  size(float  s) {return std::fabs(s);}
inline long   size(long  s) {return std::abs(s);}
inline double size(const double & s) {return fabs(s);}
inline double size(const std::complex<double> & s) {return fabs(s.real()) +fabs(s.imag());}
inline double Size( double s ) { return Norm(s); };


__END_NAMESPACE_SYNAPS

#endif // SYNAPS_ARITHM_NORM_H
