#ifndef SYNAPS_ARITHM_TRAITS_ISEXACT_H
#define SYNAPS_ARITHM_TRAITS_ISEXACT_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<typename X>
  struct isexact_ { typedef type::false_t T; };
  
  template<class K, class X>
  struct kernel_isexact  { typedef true_t T; };

  template<class X>
  struct kernel_isexact<null_t,X> { typedef typename isexact_<X>::T T; };
  template<class K>
  struct kernel_isexact< K, typename K::ieee >  { typedef false_t T; };
  template<class K>
  struct kernel_isexact< K, typename K::floating > { typedef false_t T; };

  template<typename X>
  struct isexact 
  {
    typedef  typename ucstref<X>::T   _X;
    typedef  typename kernel_isexact< typename kernelof<X>::T, _X >::T T;
  };
  
  template<typename X>
  struct isapproximate { typedef typename tnot< typename isexact< X >::T >::T T; };

}

__END_NAMESPACE_SYNAPS

#endif


