#ifndef SYNAPS_ARITHM_TRAITS_ISFIELD_H
#define SYNAPS_ARITHM_TRAITS_ISFIELD_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<typename X>
  struct isfield_ { typedef false_t T; };
  
  template<> struct isfield_<float>       { typedef true_t T; };
  template<> struct isfield_<double>      { typedef true_t T; };
  template<> struct isfield_<long double> { typedef true_t T; };

  template<typename K, typename X>
  struct kernel_isfield { typedef true_t T; };
  template<typename K>
  struct kernel_isfield< K, typename K::integer > { typedef false_t T; };
  template<typename X>
  struct kernel_isfield<null_t,X> { typedef typename isfield_<X>::T T; };
  
  template<typename X>
  struct isfield
  {
    typedef  typename ucstref<X>::T   _X;
    typedef  typename kernel_isfield< typename kernelof<_X>::T, _X >::T T;
  };

};

__END_NAMESPACE_SYNAPS

#endif
