#ifndef SYNAPS_ARITHM_TRAITS_ISIEEE_H
#define SYNAPS_ARITHM_TRAITS_ISIEEE_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<class X> struct isieee_  { typedef false_t T; };

  template<> struct isieee_<int> { typedef true_t T; };
  template<> struct isieee_<long int> { typedef true_t T; };

  template<class K, class X>
  struct kernel_isieee  { typedef false_t T; };
  template<class K>
  struct kernel_isieee< K, typename K::ieee >  { typedef true_t T; };
  
  template<class X> struct isieee 
  {
    typedef typename ucstref <X>::T _X;
    typename kernel_isieee< typename kernelof<_X>::T,_X>::T T;
  };

}
__END_NAMESPACE_SYNAPS

#endif
