#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP

#include <iostream>
#include <synaps/arithm/gmp.h>
#include <synaps/arithm/diadic.h>

using std::cout;
using std::endl;

int main (int argc, char *argv[])
{

  ZZ a("2324352131"), b(3);
  diadic<ZZ> da(a,-3), db(b,-2), dc( ZZ("111111"),-5), dd(3,-5);
  
  cout <<"A: "<<da<<endl;
  cout <<"B: "<<db<<endl;
  cout <<"C: "<<dc<<endl;
  cout <<"D: "<<dd<<endl;
  cout <<"A+B:"<<(da+db)<<endl;  
  assert((da+db)==diadic<ZZ>(ZZ("2324352137"),-3));
  cout <<"A+C:"<<(da+dc)<<endl;
  cout <<"(A+B)/2: "<< (da+db)/2<<endl;
  cout <<"A-B: "<<(da-db)<<endl;
  cout <<"A*B: "<<(da*db)<<endl;
  cout <<"A/B: "<<(da/db)<<endl;
  cout <<"A<B: "<<(da<db)<<endl;
  cout <<"A>C: "<<(da>dc)<<endl;
  assert(0<db);
  assert(!(db>1));
}
#else 
//======================================================================
#include <iostream>
int main()
{
  std::cout <<"  Gmp is not connected"<<std::endl;
  return(77);
}
#endif //SYNAPS_WITH_GMP
