<TeXmacs|1.0.6>

<style|generic>

<\body>
  <section|Sequence>

  They are implemented as\ 

  <\quote-env>
    <\code>
      template\<less\>class C, class R=std::vector\<less\>C\<gtr\> \<gtr\>
      struct Seq;
    </code>
  </quote-env>

  where

  <\itemize>
    <item><verbatim|C> is the type of elements stored in the sequence.

    <item><verbatim|R> is the internal representation. The default is
    <verbatim|std::vector\<less\>C\<gtr\>>.
  </itemize>

  <subsection|Example>

  <\quote-env>
    <\code>
      Seq\<less\>double\<gtr\> s("3.1 3.2");

      s.push_back(3.3);\ 

      s[1]; \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ //yield 3.2

      Seq\<less\>double\<gtr\> t = s,s; \ \ //concatenation of the sequence
    </code>
  </quote-env>

  <subsection|Implementation>

  See: <verbatim|synaps/base/Seq.h>

  \;

  \;
</body>

<\initial>
  <\collection>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|toc-1|<tuple|<uninit>|?>>
    <associate|toc-2|<tuple|<uninit>|?>>
    <associate|toc-3|<tuple|<uninit>|?>>
    <associate|toc-4|<tuple|<uninit>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Sequence>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|Example
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>
    </associate>
  </collection>
</auxiliary>