#ifndef SYNAPS_UTIL_COUNT_H
#define SYNAPS_UTIL_COUNT_H


#ifdef MEMORY_INFO

#include <iostream>
#include <typeinfo>
#include <map>
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS

template < typename T >
struct counter {
	typedef map<char,unsigned> rep_t;

	rep_t ctr;

	counter(){}

	void incr(char c) {ctr[c]++;}

	~counter() {
		typedef typename rep_t::const_iterator const_iterator;
		std::cout<<__PRETTY_FUNCTION__<<std::endl;
		//typeid(T).name()<<endl;
		for(const_iterator i = ctr.begin(); i!= ctr.end();i++) {
			if(i->first==' ')
				std::cout <<"    constructor ()  : "<<i->second<<std::endl;
			else if(i->first=='c')
				std::cout <<"    constructor copy: "<<i->second<<std::endl;
			else if(i->first=='=')
				std::cout <<"    operator =      : "<<i->second<<std::endl;
			else
				std::cout <<"    "<<i->first<<"               : "<<i->second<<std::endl;
		}
	}
};

template < typename T >
struct COUNT {
  static counter<T> _counter;
  COUNT(){}
  COUNT(char c) {COUNT<T>::_counter.incr(c);}
};

template < typename T > counter<T> COUNT<T>::_counter;


__END_NAMESPACE_SYNAPS

#else

__BEGIN_NAMESPACE_SYNAPS

template<class T> struct COUNT {
  COUNT(){}
  COUNT(char c){}
};

__END_NAMESPACE_SYNAPS

#endif // MEMORY_INFO

#endif //COUNT_H


