/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
History:
$Id: Error.h,v 1.1 2005/07/11 11:23:11 mourrain Exp $
**********************************************************************/
//====================================================================
//  Fichier d'entete contenant quelques fonctions utiles
#ifndef SYNAPS_UTIL_ERROR_H
#define SYNAPS_UTIL_ERROR_H


#include <stdio.h>
#include <stdarg.h>
#include <fstream>
#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

// Messages d'erreurs
const char * ERR_SPACE = "\n NOT ENOUGH MEMORY ";
const char * ERR_RANGE =  "\n INDEX OUT OF RANGE ";
const char * ERR_INIT =  "\n INITIALIZATIONS NOT PERFECT ";
const char * ERR_OPEN_FILE =  "\n IMPOSSIBLE TO OPEN FILE ";
const char * ERR_DIM =  "\n Dimension check failure ";
const char * ERR_POSITIVE = "\n Exposant not positive ";
const char * ERR_FUNCTION =  "Function: ";
const char * ERR_CONSTRUCTOR =  "Constructor: ";
const char * ERR_OPERATOR =  "Operator: ";
const char * ERR_METH =  "Method: ";
const char * MFORMAT = "%G" ;


// Afficher les messages d'errreur
void Error(char *myformat,...)
{
  va_list argPointer;
  va_start(argPointer,myformat);
  vfprintf(stderr,myformat,argPointer);
  va_end(argPointer);
  exit(1);
}

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_UTIL_ERROR_H
