#ifndef SYNAPS_UTIL_TYPE_TESTS_H
#define SYNAPS_UTIL_TYPE_TESTS_H
#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

namespace Type
{
  struct false_t{};
  struct true_t{};
  struct null_t {};
  template<bool test, class A, class B>
  struct If 
  { 
    typedef A result_t;  
  };
  
  template<class A,class B>
  struct If<false,A,B> 
  { 
    typedef B result_t; 
  };
  
  template<class A,class B>
  struct Eq 
  { 
    enum { result = 0 }; 
    typedef false_t result_t; 
  };
  
  template<class A>
  struct Eq<A,A> 
  { 
    enum { result = 1 }; 
    typedef true_t result_t; 
  };
  
  template<class A>
  struct ValueType
  { 
    typedef typename A::value_type result_t; 
  };
  
  template<class A, int n >
  struct ValueType< A[n] >
  {
    typedef A result_t;
  };
  template<class A>
  struct ValueType<A*>
  { 
    typedef  A result_t; 
  };
  
  template<int n>
  struct Int {};
  
  template<bool b> struct BoolType { typedef false_t result_t; };
  template<> struct BoolType<true> { typedef true_t result_t; };

  template<class X>
  struct deconst{
    typedef X result_t;
  };
  template<class X>
  struct deconst< const X> { typedef X result_t; };

  template<class A,class B>
  struct Sup
  {
    typedef typename deconst<A>::result_t result_t;
  };
  
  template<class el, class nx>
  struct Pair
  {
    typedef el element_t;
    typedef nx next_t;
  };
  
};

#define typelist1(a)     Type::Pair< a, Type::null_t >
#define typelist2(a,b)   Type::Pair< a, typelist1(b) >
#define typelist3(a,b,c) Type::Pair< a, typelist2(b,c) >
#define typelist4(a,b,c) Type::Pair< a, typelist3(b,c,d) >

__END_NAMESPACE_SYNAPS

#endif
