/*******************************************************************
 *   This file is part of the source code of the AXEL library.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 *   $Id: $
 ********************************************************************/
#ifndef SYNAPS_VIEWER_COLOR_H
#define SYNAPS_VIEWER_COLOR_H
//====================================================================
#include <synaps/init.h>
#include <iostream>

__BEGIN_NAMESPACE_SYNAPS
struct Color
{
  float r,g,b;
  Color(): r(0.314),g(0.979),b(1){}
  Color(float x, float y, float z): r(x),g(y),b(z){}
  Color(const Color& c): r(c.r),g(c.g),b(c.b){}
  Color& operator= (const Color & c)
  {
    r=c.r; g=c.g; b=c.b; return *this;
  }
};

inline std::ostream& operator<<(std::ostream& os, const Color & c)
{
  os <<"Color("<<c.r<<","<<c.g<<","<<c.b<<")"; return os;
}

__END_NAMESPACE_SYNAPS
//====================================================================
#endif 
