#ifndef SYNAPS_BASE_TYPE_STRIPQUALIFIERS_H
#define SYNAPS_BASE_TYPE_STRIPQUALIFIERS_H
#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

namespace type 
{
  /// return T = Y * from X = Y or X = Y *
  template <class X> struct  ptr     { typedef X * T; };
  template <class X> struct  ptr<X*> { typedef X * T; };
  template <class X> struct  ptr<X* const> { typedef X * const T; };
  /// return T = Y   from X = Y or X = Y *
  template <class X> struct uptr     { typedef X   T; };
  template <class X> struct uptr<X*> { typedef X   T; };
  /// return T = Y & from X = Y or X = Y &
  template <class X> struct  ref     { typedef X & T; };
  template <class X> struct  ref<X&> { typedef X & T; };
  /// return T = Y   from X = Y or X = Y &
  template <class X> struct uref     { typedef X   T; }; 
  template <class X> struct uref<X&> { typedef X   T; };
  /// return T = const Y from X = Y or X = const Y
  template <class X> struct  cst          { typedef const X T; };
  template <class X> struct  cst<const X> { typedef const X T; };
  /// return T = Y from X = Y or X = const Y
  template <class X> struct ucst          { typedef X T; };
  template <class X> struct ucst<const X> { typedef X T; };
  /// return T = Y from X = const Y, Y, Y &, const Y &
  template <class X> struct ucstref  { typedef typename uref< typename ucst<X>::T >::T T; };
};

__END_NAMESPACE_SYNAPS

#endif
