<TeXmacs|1.0.6>

<style|generic>

<\body>
  <section|Developer corner>

  <subsection|An account on the server>

  If you want to contribute to the development of the library, contact
  <verbatim|mourrain@sophia.inria.fr>. You will \ get an account on the svn
  server:\ 

  <verbatim|http://gforge.inria.fr/projects/synaps/>

  In order to get the last version of the library, follow the instructions
  given here:

  <verbatim|http://gforge.inria.fr/scm/?group_id=93>

  <subsection|How to install the developer version>

  In order to build the development version of the library, you have to type

  <\code>
    ./smake\ 
  </code>

  and then

  <\code>
    ./configure \<less\>options\<gtr\>; make
  </code>

  The script <verbatim|smake> can also be used with a ressource file:

  <\code>
    ./smake resource
  </code>

  which contains information on the version and on the list of modules:

  <\code>
    SYNAPS_VERSION = 2.5.0\ 

    MODULES = base arithm linalg upol usolve mpol msolve topology map shape

    EXTERNAL_MODULES = mpsolve sisl
  </code>

  <subsection|How to add your contribution>

  Before you commit anything, please type

  <\code>
    make check
  </code>

  Then, if the test run correctly, you can commit your work:\ 

  <\code>
    svn commit\ 
  </code>

  The code which is added to the library should be tested (test files in the
  directory <verbatim|test> of the package) and documented (documentation
  file in the directory <verbatim|doc> of the package).

  <subsection|The package structure>

  In order to simplify the process of adding and updating packages, we use
  the following rules. The comon configuration files are put in the directory
  <verbatim|install>. The files <verbatim|Makefile.am> of the other directory
  are then included the correspdonfing <verbatim|makefile-*>, depending if it
  is in a <verbatim|bin>, <verbatim|doc>, <verbatim|include>, <verbatim|src>
  directory. Here is the example of <verbatim|synaps/usolve/include/Makefile.am>:\ 

  <\code>
    SUBDIRS = algebraic sturm bezier weierstrass

    include ../../install/makefile-include
  </code>

  One can use also the variable <verbatim|top_srcdir> to refer to the root
  directory of the library.\ 

  <subsection|The documentation>

  The documentation files are put in the directory <verbatim|doc> of a
  package. They are written using <name|texmacs> and processed using
  <name|doxygen>. In order to produce a <verbatim|html> documentation, you
  need these two commands. By typing in the root directory of the library,

  <\code>
    make html\ 
  </code>

  you will transform the <verbatim|.tm> files into <verbatim|.dxg> files
  (using <name|texmacs> to produce intermediate <verbatim|.tex> files) and
  run <name|doxygen> on the source code and documentation files.\ 

  By typing, in the directory <verbatim|doc> of a package,\ 

  <\code>
    make dxg
  </code>

  you will run <name|doxygen> on this package and get the corresponding
  <verbatim|html> documentation from the file <verbatim|./html/index.html>

  \ 
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|auto-4|<tuple|1.3|?>>
    <associate|auto-5|<tuple|1.4|?>>
    <associate|auto-6|<tuple|1.5|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Developer
      corner> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|An account on the server
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|How to install the developer version
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|How to add your contribution
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|The package structure
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|1.5fn>|The documentation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>
    </associate>
  </collection>
</auxiliary>