#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP
#include <synaps/arithm/gmp.h>
#include <synaps/upol/UPolDse.h>
#include <synaps/usolve/bezier/SlvBzStd.h>
#include <synaps/usolve/bezier/SlvBzBdg.h>
#include <synaps/usolve/bezier/IslBzStd.h>

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  UPolDse<ZZ> p("x^7-2324325131254354*x-1");
  cout<<p<<endl;

  cout<<solve(p, SlvBzStd<double,double>())<<endl;
  cout<<solve(p, SlvBzBdg<double,QQ>(), -400., 500.)<<endl;
  cout<<solve(p, IslBzStd<QQ,QQ>())<<endl;
  
}
#else
int main(int argc, char** argv) {}
#endif //SYNAPS_WITH_GMP
