# include <synaps/shape/surfaces/MPDRationalSurface.h>
# include <synaps/shape/interfaces/IGLGood.h>
# include <synaps/shape/surfaces/axel.h>

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  MPolDseRationalSurface<double> s1, s2;

  s1.setEquations("s^2+t^2+1", "s-1+t^2", "s^2", "t^2", "s t");
  s1.setRange( -1, 1, -1, 1);

  s2.setEquations("s^2+t^2+1", "s*t-1", "t^2", "1-s^2", "s t");
  s2.setRange(  -1., 1., -1., 0.5);
  
  axel::ostream vw("tmp3.axl");
  vw<<s1;
  vw<<Color(25,25,225);
  vw<<s2;
  IShape * r=intersect(&s1,&s2);
  IGLGood* g= r->mesh();
  vw << *g;
  vw.view();

}
