/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
History: 
$Id: bignum.h,v 1.3 2005/08/29 14:30:15 mourrain Exp $
**********************************************************************/
#ifndef SYNAPS_BIGNUM_H
#define SYNAPS_BIGNUM_H

#include <synaps/init.h>

#ifdef HAVE_CONFIG_H
	#include <synaps/config.h>
#endif

#include <cstdio>
#include <iostream>

#ifdef SYNAPS_WITH_GMP

#include <synaps/arithm/gmp.h>

#endif //SYNAPS_WITH_GMP


#ifdef SYNAPS_WITH_MPSOLVE

#include <synaps/arithm/CC.h>

__BEGIN_NAMESPACE_SYNAPS

template<>  struct RealOf<CC>  {typedef RR TYPE;};
template<>  struct AlgClos<RR> {typedef CC TYPE;};
template<>  struct AlgClos<CC> {typedef CC TYPE;};

__END_NAMESPACE_SYNAPS

#endif // SYNAPS_WITH_MPSOLVE

#endif // SYNAPS_BIGNUM_H

