dnl @synopsis RX_PROG_GXX_VERSION(X.Y [, ACTION-IF-YES [, ACTION-IF-NO]])
dnl
dnl This macro...
dnl
AC_DEFUN([RX_PROG_GXX_VERSION],[dnl
AC_REQUIRE([AC_PROG_AWK])
AC_LANG_PUSH(C++)
if test "x$CXX" != "x" -a "x$GXX" != "x"; then
  AC_MSG_CHECKING([for g++ version greater than or equal to $1])
  if test -n "$AWK"; then
    ac_gxx_minversion=`echo "$1" | ${AWK} -F. '{ print @S|@1 * 10000 + @S|@2 * 100 + @S|@3; }'`
    AC_TRY_RUN([
#ifdef __cplusplus
int main (int argc, char **argv)
#else
int main (argc, argv)
  int argc; char **argv;
#endif
{
#ifndef __GNUC_PATCHLEVEL__
#define __GNUC_PATCHLEVEL__ 0
#endif
  if (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__
	 >= $ac_gxx_minversion)
    return 0;
  else
    return 1;
}],
    [ac_gxx_version_ok=yes],
    [ac_gxx_version_ok=no])
  else
    ac_gxx_minversion="$1"
    AC_TRY_RUN([
#ifdef __cplusplus
int main (int argc, char **argv)
#else
int main (argc, argv)
  int argc; char **argv;
#endif
{
  int sub, version, i;
  char *vtext;
  vtext = "$ac_gxx_minversion";
  for (sub = version = 0, i = 0; vtext[i] != '\0'; i++) {
    if (vtext[i] >= '0' && vtext[i] <= '9')
      sub = sub * 10 + (vtext[i] - '0');
    else if (vtext[i] == '.') {
      version = version * 100 + sub; sub = 0;
    }
  }
  version = version * 100 + sub;
#ifndef __GNUC_PATCHLEVEL__
#define __GNUC_PATCHLEVEL__ 0
#endif
  if (version == 0) return 0;
  while (version < 10000) version *= 100;
  if (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__ >= version)
    return 0;
  else
    return 1;
}],
    [ac_gxx_version_ok=yes],
    [ac_gxx_version_ok=no])
  fi
  if test x"$ac_gxx_version_ok" = xyes; then
    AC_MSG_RESULT([yes])
    $2
  else
    AC_MSG_RESULT([no])
    $3
  fi
else
  AC_MSG_NOTICE([C++ compiler is not g++, version check not done.])
fi
AC_LANG_POP
])dnl
