<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Sparse matrices>

  A sparse matrix is a matrix which number of non-zero terms is very small
  compared to its size. It presents some great advantages, like reducing the
  memory space required to store it and reducing the global number of
  arithmetic operations used for computations of the product matrix-vector
  for instance. Nowdays, many numerical and efficient algorithms are based on
  sparse linear algebra (PDE, Graph theory,..., see <cite|Saad96>). In such
  applications it is not rare to treat (sparse) matrices of size
  <with|mode|math|10<rsup|4>\<times\>10<rsup|4>> or even
  <with|mode|math|10<rsup|5>\<times\>10<rsup|5>>, which could not be managed
  as dense matrices.

  It is implemented as\ 

  <\quote-env>
    <\code>
      template\<less\>class C, class R=sparse::rep2d\<less\>C\<gtr\> \<gtr\>
      struct MatrSps;
    </code>
  </quote-env>

  where\ 

  <\itemize>
    <item><verbatim|C> is the type of coefficients.

    <item><verbatim|R> is the type of the internal representation.
  </itemize>

  <subsection|Container>

  <\itemize>
    <item>The default value for the container is <verbatim|sparse::rep2d>.
  </itemize>

  <subsection|Implementation>

  See: <verbatim|synaps/linalg/MatrSps.h>.
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|toc-1|<tuple|1|?>>
    <associate|toc-2|<tuple|1.1|?>>
    <associate|toc-3|<tuple|1.2|?>>
    <associate|toc-4|<tuple|1.3|?>>
    <associate|toc-5|<tuple|<uninit>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|bib>
      Saad96
    </associate>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Sparse
      matrices> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Container
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>
    </associate>
  </collection>
</auxiliary>