/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
History: 
$Id: MatrSps.C,v 1.1 2005/07/11 08:33:34 mourrain Exp $
**********************************************************************/

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

//----------------------------------------------------------------------
/// Swap rows @i@ and @j@.
template<class C, class R>
MatrSps<C,R> & MatrSps<C,R>::swaprow(const typename MatrSps<C,R>::size_type i, 
			const typename MatrSps<C,R>::size_type j)
{
  if(i!=j) swaprow(rep(),i,j);
  return *this;
}
//----------------------------------------------------------------------
/// Swap columns @i@ and @j@.
template<class C, class R>
MatrSps<C,R> & MatrSps<C,R>::swapcol(const typename MatrSps<C,R>::size_type i, 
			const typename MatrSps<C,R>::size_type j)
{
  if(i!=j) swapcol(rep(),i,j);
  return *this;
}

__END_NAMESPACE_SYNAPS

