/* 
 * Purpose
 * ======= 
 *	Returns the time in seconds used by the process.
 *
 * Note: the timer function call is machine dependent. Use conditional
 *       compilation to choose the appropriate function.
 *
 */


#ifdef SUN 
/*
 * 	It uses the system call gethrtime(3C), which is accurate to 
 *	nanoseconds. 
*/
//#include <sys/time.h>
 
double SuperLU_timer_() {
    return ( (double)gethrtime() / 1e9 );
}

#else

//#ifdef HAVE_CONFIG_H
//#include <synaps/config.h>
//#endif
//#ifdef HAVE_UNISTD_H
//#include <unistd.h>
//#endif
//#include <sys/times.h>

double SuperLU_timer_()
{
    struct tms use;
    double tmp;
    long clk_tck;
    times(&use);
    tmp = use.tms_utime;
    tmp += use.tms_stime;
#ifdef HAVE_UNISTD_H
    clk_tck = sysconf(_SC_CLK_TCK);
#else
    clk_tck = 1;//CLK_TCK;
#endif
    return (double)(tmp) / clk_tck;
}

#endif
