#ifndef SYNAPS_LINALG_TEXP_H
#define SYNAPS_LINALG_TEXP_H
#include <synaps/init.h>
#include <synaps/arithm/texp.h>
#include <synaps/base/Range.h>
#include <synaps/linalg/VectDse.h> // a cause de texp 

__BEGIN_NAMESPACE_SYNAPS


namespace linalg 
{ 
  define_binary_operator(_submatrix_,submatrix,submatrix);
  define_binary_operator(_row_,row,row);
  define_binary_operator(_col_,col,col);
};

namespace arithm { 
  
  template<> struct template_expression_operand< Range2d > { typedef Range2d T; }; 
  
  
  template<class Matrix> struct binary_operator_prototype< linalg::_row_, Matrix, Range >
  {
    typedef Matrix                        F;
    typedef Matrix                        U;
    typedef Range                         V;
  };
  
  template<class Matrix> struct binary_operator_prototype< linalg::_col_, Matrix, Range >
  {
    typedef Matrix                        F;
    typedef Matrix                        U;
    typedef Range                         V;
  };
  
  template<class Matrix> struct binary_operator_prototype< linalg::_row_, Matrix, int >
  {
    typedef typename Matrix::row_type       F;
    typedef Matrix                          U;
    typedef int                             V;
  };
  
  template<class Matrix> struct binary_operator_prototype< linalg::_col_, Matrix, int >
  {
    typedef typename Matrix::col_type     F;
    typedef Matrix                        U;
    typedef int                           V;
  };
};
__END_NAMESPACE_SYNAPS
#endif
