<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|Monomials>

  They are parameterised by a coefficient type <verbatim|C> and an exponent
  type <verbatim|R>:

  <\quote-env>
    <\code>
      template\<less\>class C, class R\<gtr\> struct Monom;
    </code>
  </quote-env>

  The container <verbatim|R> should provide the following definitions:

  <\quote-env>
    <\code>
      typedef R::exponent_type;

      typedef R::intex_type

      exponent_type R::operator[](index_type i);

      void R::.setExponent(index_type i, exponent_type d);
    </code>
  </quote-env>

  This class allows to define monomials with arbitrary variables:
  <verbatim|x1, a, b, aa,...>. A static association table stores the
  correspondance between the variables read and their index in <verbatim|R>.

  <subsection|Implementation>

  See: <verbatim|synaps/mpol/Monomial.h>
</body>

<\initial>
  <\collection>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.2|?>>
    <associate|toc-1|<tuple|1|?>>
    <associate|toc-2|<tuple|1.1|?>>
    <associate|toc-3|<tuple|1.2|?>>
    <associate|toc-4|<tuple|1.3|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>Monomials>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>Implementation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>
    </associate>
  </collection>
</auxiliary>