#ifndef synaps_mpol_let_H
#define synaps_mpol_let_H  
#include <synaps/init.h>
#include <synaps/arithm/let.h>
__BEGIN_NAMESPACE_SYNAPS

namespace let { 
  
  template<class POL, class C, class R>
    POL convert(const Monom<C,R> & m, type::As<POL> ) { return POL(m.coeff(),m[0]); };
  
  template<class C, class R>
    C convert(const Monom<C,R> & m, type::As<C> ) { return m.coeff(); }
  
  template<class U,class S, class C, class O,class R>
    void assign(UPolDse< U, S> & u, const MPol<C,O,R> & p, int v)
  {
    int d= degree(p,v);
    u.resize(d+1);
    for( unsigned i=0;i<u.size();++i) u[i]=0; //VECTOR::init(u,(U)0);
    for(typename MPol<C,O,R>::const_iterator it=p.begin(); it !=p.end(); ++it)
      {
	u[(*it)[v]] += let::convert(*it,type::As<U>());
      }
  }
}

__END_NAMESPACE_SYNAPS
#endif
