#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP

#define USING_NAMESPACE_SYNAPS 1
#include <synaps/mpol/elim.h>

/**
  \param : S name of the file contained the polynomials
**/
int main(int argc, char** argv)
{
  typedef QQ coeff_t;
  typedef MPol<coeff_t> mpol_t;
  typedef std::vector<mpol_t> ListPol;

  using std::cout;
  using std::cin;
  using std::endl;

  ListPol h;
  h.push_back(mpol_t("1"));
  h.push_back(mpol_t("3*x0^2*x1+3*x1-x1^3"));
  h.push_back(mpol_t("3*x0*x1^2+3*x0-x0^3"));
  h.push_back(mpol_t("-3*x0^2+3*x1^2"));

  cout<<"Rational map:"<<endl;
  VECTOR::print(std::cout,h);
  ListPol f = transformType<ListPol>(h);
  mpol_t p = Elim_Bezout(f);
  cout<<"Resulting equation: \n"<<p<<" = 0\n";
  cout<<"degree : "<<degree(p)<<'\n';

  p = Elim_Macaulay(f);
  cout<<"Resulting equation: \n"<<p<<" = 0\n";
  cout<<"degree : "<<degree(p)<<'\n';

}
#else 
//======================================================================
#include <iostream>
int main()
{
  std::cout <<"  Gmp is not connected"<<std::endl;
  return(77);
}
#endif //SYNAPS_WITH_GMP
