#include <synaps/init.h>
#include <synaps/mpol.h>
#include <synaps/base/Seq.h>
#include <synaps/msolve/sbdslv.h>

typedef MPol<double> mpol_t;

int main (int argc, char **argv)
{
  using namespace std;

  mpol_t p("x0^2*x1-x0*x1-1"), q("x0^2-x1^3-1");

  std::list<mpol_t> I; I.push_back(p); I.push_back(q);

  VectDse<double> dmn(4,"-2 2 -2 2");
  cout << Solve(I, SBDSLV<double,VectDse<double>,SBDSLV_RDL>())<<endl;
  cout << Solve(I, SBDSLV<double,VectDse<double>,SBDSLV_RDL>(dmn))<<endl;

  //| [  1.5648 1.13148 ]
  //| [ -1.04912 0.465166 ]

  // The result is a dense matrix of double type.
  // The columns correspond to the coordinates of the roots (here x0, x1).
  // The rows correspond to the roots of the system.
  // Here they are no solutions in the default [0,1]x[0,1] and
  // 2 real solutions in the box [-2,2]x[-2,2]).

}

