
#include <synaps/init.h>
#include <list>

__BEGIN_NAMESPACE_SYNAPS

template<typename T>
inline typename T::value_type& elemwrite(T & Obj,const int i,
		    const typename T::value_type & val)
{
  typename T::iterator iter=Obj.begin();
  for(int j=0;j<i;iter++,j++);
  return (*iter=val);
}

template<typename T> 
inline typename  T::value_type & elemread(T & Obj,const int i)
{
  typename T::iterator iter=Obj.begin();
  for (int j=0;j<i;iter++,j++);
  return (*iter);
}
template <typename typmat,typename typPk>
typPk& SolveU(const typmat & u ,typPk &Pk)
{
  typedef typename typPk::value_type elem_typ;
  typedef typename elem_typ::monom_t mon;
  typedef typename elem_typ::coeff_t coeff; 
  int t;
  for(int i=u.ncol-1;i>=0;i--)
    //    if (!Iszero(u(i,i)))
      {
	for (int j=(t=(i==(u.ncol-1))?(u.nnz-1):(u.colptr[i+1]-1))
	       ;(j>=(u.colptr)[i]);j--)
	  {
	    if (i==u.rowind[j])//t==j 
	    {
	      if (Iszero(((coeff*)u.nzval)[j])) 
		//le system est il "degenere"?
		{//elemwrite(Pk,u.rowind[j],(elem_typ)(0));continue;}
		   break;
		}
	      //oui on met 0 et on a 
	      //plus rien a faire pour cette colonne
	      else//non on calcule
		{
		  elemwrite(Pk,u.rowind[j],elemread(Pk,u.rowind[j])
			    *((coeff)(1)/((coeff*)u.nzval)[j]));
		}
	    }
	  else {
	    if(!Iszero(((coeff*)u.nzval)[j]))
	      {
		elemread(Pk,u.rowind[j])-=
		  elemread(Pk,i)*(((coeff*)u.nzval)[j]);
		elemread(Pk,i)*(1/(((coeff*)u.nzval)[j]));
	      }
	  }
	}
    }
  return Pk;
}
template <typename T,typename typPk>
typPk& SolveU(const sparse::rep2d<T> & u ,typPk &Pk)
{
  typedef typename typPk::value_type elem_typ;
  typedef typename elem_typ::monom_t mon;
  typedef typename elem_typ::coeff_t coeff; 
  int t;
  for(int i=u.ncol-1;i>=0;i--)
      {
	T mult_coeff=(T)1;
	for (int j=(t=(i==(u.ncol-1))?(u.nnz-1):(u.colptr[i+1]-1))
	       ;(j>=(u.colptr)[i]);j--)
	  if (i==u.rowind[j]) {
	    mult_coeff=((T*)u.nzval)[j];
	  }
	if(Iszero(mult_coeff)) continue;
	for (int j=(t=(i==(u.ncol-1))?(u.nnz-1):(u.colptr[i+1]-1))
	       ;(j>=(u.colptr)[i]);j--)
	  {
	    if (i==u.rowind[j])//t==j 
	    {
	      if (Iszero(((T*)u.nzval)[j])) 
		//le system est il "degenere"?
		{//elemwrite(Pk,u.rowind[j],(elem_typ)(0));continue;}
		  break;
		}
	      //oui on met 0 et on a 
	      //plus rien a faire pour cette colonne
	      else//non on calcule
		{
		   mult_coeff=coeff(1);
		   elemwrite(Pk,u.rowind[j],
			     elemread(Pk,u.rowind[j])*
			     mon((coeff)(((coeff)(1)/((coeff*)u.nzval)[j]))));
		}
	    }
	  else {
	    if(((T*)u.nzval)[j]!=(coeff)0)
	      {
		elemread(Pk,u.rowind[j])-=
		 elemread(Pk,i)*mon((coeff)(((coeff*)u.nzval)[j]/mult_coeff));
	      }
	  }
	}
    }
  // cout<<"exit SolveU"<<endl;
  return Pk;
}
//--------------------------------------------------------------------
//template<class T> struct harewell;
//--------------------------------------------------------------------
template <typename T,typename mono>
std::list<pol<mono,T> >& 
SolveU(const sparse::rep2d<T> & u ,
       std::list<pol<mono,T> > &Pk)
{
  typedef std::list<pol<mono,T> > typPk;
  typedef typename typPk::value_type elem_typ;
  typedef typename elem_typ::monom_t mon;
  typedef typename elem_typ::coeff_t coeff; 
  int t;
  std::vector<pol<mono,T> > tmpPk;
  for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
    tmpPk.push_back(*iter);
  Pk.erase(Pk.begin(),Pk.end());
  
  for(int i=u.ncol-1;i>=0;i--)
      {
	T mult_coeff=(T)1;
	for (int j=(t=(i==(u.ncol-1))?(u.nnz-1):(u.colptr[i+1]-1))
	       ;(j>=(u.colptr)[i]);j--)
	  if (i==u.rowind[j]) {
	    mult_coeff=((T*)u.nzval)[j];
	  }
	if(Iszero(mult_coeff)) continue;
	mult_coeff=((coeff)1)/mult_coeff;
	for (int j=(t=(i==(u.ncol-1))?(u.nnz-1):(u.colptr[i+1]-1))
	       ;(j>=(u.colptr)[i]);j--)
	  {
	    if (i==u.rowind[j])//t==j 
	    {
	      if (Iszero(((T*)u.nzval)[j])) 
		//le system est il "degenere"?
		{//elemwrite(Pk,u.rowind[j],(elem_typ)(0));continue;}
		  break;
		}
	      //oui on met 0 et on a 
	      //plus rien a faire pour cette colonne
	      else//non on calcule
		{
		  mult_coeff=coeff(1);
		  tmpPk[u.rowind[j]]*
		    (coeff)(((coeff)(1)/((coeff*)u.nzval)[j]));
		}
	    }
	  else {
	    if(((T*)u.nzval)[j]!=(coeff)0)
	      {
		my_plus(tmpPk[u.rowind[j]],
			tmpPk[i],((coeff)(((coeff*)u.nzval)[j]*mult_coeff)));
	      }
	  }
	}
    }
  for(typename std::vector<pol<mono , T> >::iterator iter=tmpPk.begin()
	;iter!=tmpPk.end();iter++)
    Pk.push_back(*iter);
  return Pk;
}

template <typename typmat,typename typPk>
typPk& SolveL(const typmat &l,typPk &Pk)
{
  typedef typename typPk::value_type elem_typ;
  typedef typename elem_typ::monom_t mon;
  typedef typename elem_typ::coeff_t coeff; 
  elem_typ tmp;
  for(int i=0;i<l.ncol;i++)
    {
      for (int j=l.colptr[i];(j<l.nnz)&&(j<(l.colptr)[i+1])
	   ;j++)
      {
	if (i==l.rowind[j]) 
	  {
	    tmp=elemread(Pk,l.rowind[j]);
	    tmp=tmp*
	      mon((coeff)((coeff)(1)/((((coeff *)l.nzval))[j])));
	  }
	else 
	  {
	    if((((coeff*)l.nzval)[j])!=(coeff)0)
	      {
		elemread(Pk,l.rowind[j])
		  -=elemread(Pk,i)*mon(((coeff*)l.nzval)[j]);
		elemread(Pk,i)*mon((coeff)((coeff)1/((coeff*)l.nzval)[j]));
	      }
	  }	
      }
    }
    return Pk;
}
template <typename T,typename mono>
std::list<pol<mono,T> >& SolveL(const sparse::rep2d<T> &l,
				std::list<pol<mono,T> > &Pk)
{
  typedef std::list<pol<mono,T> > typPk;
  typedef typename typPk::value_type elem_typ;
  typedef typename elem_typ::monom_t mon;
  typedef typename elem_typ::coeff_t coeff; 
  std::vector<pol<mono,T> > tmpPk;
  for(typename typPk::iterator iter=Pk.begin();iter!=Pk.end();iter++)
    tmpPk.push_back(*iter);
  Pk.erase(Pk.begin(),Pk.end());
 
  for(int i=0;i<l.ncol;i++)
    {
      int j=l.colptr[i];
      for (;(j<l.nnz)&&(j<(l.colptr)[i+1]);j++)
      {
	if (i==l.rowind[j]) 
	  {
	  }
	else 
	  {
	    if((((coeff*)l.nzval)[j])!=(coeff)0)
	      {
		my_plus(tmpPk[l.rowind[j]]
			,tmpPk[i],(((coeff*)l.nzval)[j]));
	      }
	  }	
      }
    }
  for(typename std::vector<pol<mono , T> >::iterator iter=tmpPk.begin()
	;iter!=tmpPk.end();iter++)
    Pk.push_back(*iter);
 
  return Pk;
}

//bon on va dire que c bon 
//les appels successif au constructeur c parce que dans apl pol*scalaire 
//n'est pas (encore) supporte
template <typename LST> 
void Dopermu(LST &TildePk,int *Pr)
{
  typename LST::iterator *tab, iter=TildePk.begin();
  //  toto temp;
  tab=(typename LST::iterator *)malloc(TildePk.size()*
					      sizeof(typename LST::iterator));
  //cout<<"TildePk.size "<<endl;cout<<TildePk.size()<<endl;
  //for(unsigned int i=0;i<TildePk.size();i++)
  //  cout<<"PR["<<i<<"]:="<<Pr[i]<<";"<<endl;
  for (unsigned int i=0;iter!=TildePk.end();iter++,i++)
    {
      tab[i]=iter;
    }
  //cout<<"assign des iter fait"<<endl;
  for (int i=0;(unsigned int)i<TildePk.size();(Pr[i]==i)?i++:i)
    { 
      //  cout<<"Pr["<<i<<"]="<<Pr[i]<<endl;
      if (Pr[i]!=i)
	{
		std::swap(*(tab[i]),*(tab[Pr[i]]));
	  volatile  int t=Pr[i];
	  Pr[i]=Pr[Pr[i]];
	  Pr[t]=t;
	}
    }
  free(tab);
}
//inverse une permutation..

void inverse(int* &pr,int n)
{
  int *tmp=(int*)malloc(sizeof(int)*n);
  for(int i=0;i<n;i++)
    tmp[pr[i]]=i;
  free(pr);
  pr=tmp;
}

template<typename typmat,typename typPk> 
typPk &Solve(typmat &S, typPk &TildePk,int **pr,int **pc)
{
 typmat L,U;
  int *Pr,*Pc;//=(int*)malloc(sizeof(int)); 
  //  cout<<"    Ludecomp"<<endl;
  //Clock c;
  //c.start();
 LUdecomp(S,&L,&U,&Pr,&Pc);//les '&' c pour montrer ce que je modifie
 //cout<<"temps dans ludecomp "<<c.time()<<endl;
 //cout<<"    INVERSE"<<endl;
  //for(int i=0;i<S.nrow;i++)
  /// cout<<"pr["<<i<<"] vaut ici "<<Pr[i]<<endl;
 inverse(Pr,L.nrow);
 //for(int i=0;i<S.nrow;i++)
 //  cout<<"apres iverse pr["<<i<<"] vaut ici "<<Pr[i]<<endl;
 //cout<<" DOPERMU "<<endl;
 Dopermu(TildePk,Pr);
 //cout<<"    SolveU de solveL"<<endl;
 SolveL(L,TildePk);
 //cout<<"SolveU"<<endl;
 SolveU(S,TildePk);//SolveU(S,TildePk);
 //cout<<"    retour"<<endl;
 *pc=Pc;*pr=Pr;
 L.destroystore();
 //U.destroystore();
 //inutiles le destructeur detruit le storage
return TildePk;
}

template<typename T,typename typPk> 
typPk &Solve(sparse::rep2d<T> &S, typPk &TildePk,int **pr,int **pc)
{
 sparse::rep2d<T> L,U;
  int *Pr,*Pc;//=(int*)malloc(sizeof(int)); 
  //  cout<<"    Ludecomp"<<endl;
  //Clock c;
  //c.start();
 sparse::LUdecomp(S,&L,&U,&Pr,&Pc);//les '&' c pour montrer ce que je modifie
 //cout<<"temps dans ludecomp "<<c.time()<<endl;
 //cout<<"    INVERSE"<<endl;
  //for(int i=0;i<S.nrow;i++)
  /// cout<<"pr["<<i<<"] vaut ici "<<Pr[i]<<endl;
 inverse(Pr,L.nrow);
 //for(int i=0;i<S.nrow;i++)
 //  cout<<"apres iverse pr["<<i<<"] vaut ici "<<Pr[i]<<endl;
 //cout<<" DOPERMU "<<endl;
 Dopermu(TildePk,Pr);
 //cout<<"    SolveU de solveL"<<endl;
 SolveL(L,TildePk);
 //cout<<"SolveU"<<endl;
 SolveU(S,TildePk);//SolveU(S,TildePk);
 //cout<<"    retour"<<endl;
 *pc=Pc;*pr=Pr;
 L.destroystore();
 //U.destroystore();
 //inutiles le destructeur detruit le storage
return TildePk;
}

//fortment sous optimal a changer par la suite.
template<typename typmat, typename typPk>
typPk secondmembre(const typmat &mat, typPk & Pk)
{
  typedef typename typPk::value_type pol;
  typedef typename pol::coeff_t coeff;
  typPk res;
  int i=0;
  typename typPk::iterator iter=Pk.begin();
  //for(int i=0;i<rank(mat);i++)
  //  iter++;
  for(iter=Pk.begin();iter!=Pk.end();iter++,i++)
    if((i>=mat.ncol)||(Iszero(mat(i,i))))
      {
	if (!Ispolzero(*iter)) 
	  {
	    res.push_back(*iter);
	    res.rbegin()->ind.setcoeff(0);//PARCE QUE si on est ds le 
	    //second memebre c que coef ind =0 ce qui n'est pas le cas avant
	  }
	else
	  {
	    MAC_REV_FREE<coeff>(iter->nf,iter->size*sizeof(coeff));
	    iter->size=0;
	  }
	Pk.erase(iter--);
      }
  return res;
}

template<typename typmat, typename typPk>
void secondmembre2(const typmat &mat, typPk & Pk,typPk & secd)
{
  typedef typename typPk::value_type pol;
  typedef typename pol::coeff_t coeff;
  
  typename typPk::iterator iter=Pk.begin();
  for(int i=0;i<rank(mat);i++)
    iter++;
  for(;iter!=Pk.end();iter++)
    if (!Ispolzero(*iter)) 
      {
	secd.push_back(*iter);
	secd.rbegin()->ind.setcoeff(0);//PARCE QUE si on est ds le 
	//second memebre c que coef ind =0 ce qui n'est pas le cas avant
      }
    else
      {
	MAC_REV_FREE<coeff>(iter->nf,iter->size*sizeof(coeff));
	iter->size=0;
      }
  return ;
}


__END_NAMESPACE_SYNAPS


