/********************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): Ph. TB. Mourrain, GALAAD, INRIA
 *   $Id: io.cc,v 1.1 2005/07/11 10:03:53 jppavone Exp $
 ********************************************************************/
#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <synaps/init.h>
//--------------------------------------------------------------------
__BEGIN_NAMESPACE_SYNAPS

#define NBDIGITS 10
	
template<typename typmat>
void affdebug2(const typmat &m)
{
  using namespace std;
  cout<<"[";
	for(int i=0;i<m.nrow;i++)
	{
		cout<<"[";
		for(int j=0;j<m.ncol-1;j++)
		{
			if (m(i,j)!=0) {printf("*");} 
			else {printf(" ");} 
		}

		printf("]\n");
	}
	cout<<"]"<<endl;
}  
	template<typename typmat>
void affdebug(const typmat &m)
{
  using namespace std;
	int i;
	cout<<setprecision(6);
	cout<<"nrow "<<m.nrow<<" ncol "<<m.ncol<<endl;
	cout<<"[";
	for(i=0;i<m.nrow-1;i++)
	{
		int j;
		cout<<"[";
		for(j=0;j<m.ncol-1;j++)
			cout<<m(i,j)<<",";
		cout<<m(i,j)<<"],"<<endl;
	}
	{
		int j;
		cout<<"[";
		for(j=0;j<m.ncol-1;j++)
			cout<<m(i,j)<<",";
		cout<<m(i,j)<<"]"<<endl;
	}
	cout<<"]"<<endl<<setprecision(16);
}  

//template<template<typename T> class typmat,typename toto >
//void printmatfile(const typmat<toto> & m,char * name,FILE * fic)
//{}
#define _COMPLEX_
#ifdef _COMPLEX_
#include<complex>
	template<template<typename T> class typmat >
void printmatfile(const typmat<std::complex<double> > & m,char * name,FILE * fic)
{int i;
  using namespace std;
	fprintf(fic,"%s:=[",name);
	for(i=0;i<m.nrow-1;i++)
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			fprintf(fic,"%.16f+(%.16f)*I,",m(i,j).real(),m(i,j).imag());
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.16f+(%.16f)*I],\n",m(i,j).real(),m(i,j).imag());
	}
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			//mpq_out_str(fic,10,&(m(i,j).rep()));
			fprintf(fic,"%.16f+(%.16f)*I,",m(i,j).real(),m(i,j).imag());
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.16f+(%.16f)*I]\n];\n",m(i,j).real(),m(i,j).imag());
	}
}

template<template<typename T> class typmat >
void printmatfile(const typmat<std::complex<long double> > & m,char * name,
		FILE * fic)
{int i;
	fprintf(fic,"%s:=[",name);
	for(i=0;i<m.nrow-1;i++)
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			fprintf(fic,"%.16Lf+(%.16Lf)*I,",m(i,j).real(),m(i,j).imag());
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.16Lf+(%.16Lf)*I],\n",m(i,j).real(),m(i,j).imag());
	}
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			//mpq_out_str(fic,10,&(m(i,j).rep()));
			fprintf(fic,"%.16Lf+(%.16Lf)*I,",m(i,j).real(),m(i,j).imag());
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.16Lf+(%.16Lf)*I]\n];\n",m(i,j).real(),m(i,j).imag());
	}
}

#ifdef SYNAPS_WITH_GMP
	template<template<typename T> class typmat >
void printmatfile(const typmat<std::complex<RR> > & m,char * name,FILE * fic)
{
	int i;
	fprintf(fic,"%s:=[",name);
	for(i=0;i<m.nrow-1;i++)
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		  {
		    mpf_out_str(fic,10,NBDIGITS,m(i,j).real().rep());
		    fprintf(fic,"+I*(");
		    mpf_out_str(fic,10,NBDIGITS,m(i,j).imag().rep());
		    fprintf(fic,"),");
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		mpf_out_str(fic,10,NBDIGITS,(m(i,j).real().rep()));
		fprintf(fic,"+I*(");
		mpf_out_str(fic,10,NBDIGITS,m(i,j).imag().rep());
		fprintf(fic,")],");

		//fprintf(fic,"%.16f+(%.16f)*I],\n",m(i,j).real(),m(i,j).imag());
	}
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			//mpq_out_str(fic,10,&(m(i,j).rep()));
			mpf_out_str(fic,10,NBDIGITS,(m(i,j).real().rep()));
			fprintf(fic,"+I*(");
			mpf_out_str(fic,10,NBDIGITS,m(i,j).imag().rep());
			fprintf(fic,"),");

			//fprintf(fic,"%.16f+(%.16f)*I,",m(i,j).real(),m(i,j).imag());
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		//fprintf(fic,"%.16f+(%.16f)*I]\n];\n",m(i,j).real(),m(i,j).imag());
		mpf_out_str(fic,10,NBDIGITS,(m(i,j).real().rep()));
		fprintf(fic,"+I*(");
		mpf_out_str(fic,10,NBDIGITS,m(i,j).imag().rep());
		fprintf(fic,")]\n];\n");

	}
}
#endif //SYNAPS_WITH_GMP

	template<template<typename T> class typmat >
void printmatfilescilab(const typmat<std::complex<double> > & m,char * name,FILE * fic)
{int i;
	fprintf(fic,"%s=[",name);
	for(i=0;i<m.nrow-1;i++)
	{
		int j;
		fprintf(fic,"");
		for(j=0;j<m.ncol-1;j++)
		{
			fprintf(fic,"%.16e+(%.16e)*I,",m(i,j).real(),m(i,j).imag());
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.16e+(%.16e)*I;\n",m(i,j).real(),m(i,j).imag());
	}
	{
		int j;
		fprintf(fic,"");
		for(j=0;j<m.ncol-1;j++)
		{
			//mpq_out_str(fic,10,&(m(i,j).rep()));
			fprintf(fic,"%.16e+(%.16e)*I,",m(i,j).real(),m(i,j).imag());
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.16e+(%.16e)*I\n];\n",m(i,j).real(),m(i,j).imag());
	}
}

	template<template<typename T> class typmat >
void printmatfilescilab(const typmat<std::complex<long double> > & m,char * name,FILE * fic)
{int i;
	fprintf(fic,"%s=[",name);
	for(i=0;i<m.nrow-1;i++)
	{
		int j;
		fprintf(fic,"");
		for(j=0;j<m.ncol-1;j++)
		{
			fprintf(fic,"%.32Le+(%.32Le)*I,",m(i,j).real(),m(i,j).imag());
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.32Le+(%.32Le)*I;\n",m(i,j).real(),m(i,j).imag());
	}
	{
		int j;
		fprintf(fic,"");
		for(j=0;j<m.ncol-1;j++)
		{
			//mpq_out_str(fic,10,&(m(i,j).rep()));
			fprintf(fic,"%.32Le+(%.32Le)*I,",m(i,j).real(),m(i,j).imag());
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.32Le+(%.32Le)*I\n];\n",m(i,j).real(),m(i,j).imag());
	}
}
#endif

	template<template<typename T> class typmat >
void printmatfile(const typmat<double> & m,char * name,FILE * fic)
{
	int i;
	fprintf(fic,"%s:=[",name);
	for(i=0;i<m.nrow-1;i++)
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			fprintf(fic,"%.16f,",m(i,j));
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.16f],\n",m(i,j));
	}
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			//mpq_out_str(fic,10,&(m(i,j).rep()));
			fprintf(fic,"%.16f,",m(i,j));
		}
		//mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"%.16f]\n];\n",m(i,j));
	}
}
/*
   template<template<typename T> class typmat >
   void printmatfile(const typmat<Z<MON_PREMIER> > & m,char * name,FILE * fic)
   {
   int i;
   fprintf(fic,"%s:=[",name);
   for(i=0;i<m.nrow-1;i++)
   {
   int j;
   fprintf(fic,"[");
   for(j=0;j<m.ncol-1;j++)
   {
   fprintf(fic,"%d,",m(i,j).rep);
   }
//mpq_out_str(fic,10,&(m(i,j).rep()));
fprintf(fic,"%d],\n",m(i,j).rep);
}
{
int j;
fprintf(fic,"[");
for(j=0;j<m.ncol-1;j++)
{
//mpq_out_str(fic,10,&(m(i,j).rep()));
fprintf(fic,"%d,",m(i,j).rep);
}
//mpq_out_str(fic,10,&(m(i,j).rep()));
fprintf(fic,"%d]\n];\n",m(i,j).rep);
}
}
*/

#ifdef SYNAPS_WITH_GMP
	template<template<typename T> class typmat >
void printmatfile(const typmat<QQ> & m,char * name,FILE * fic)
{
	int i;
	fprintf(fic,"%s:=[",name);
	for(i=0;i<m.nrow-1;i++)
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			mpq_out_str(fic,10,&(m(i,j).rep()));
			fprintf(fic,",");
		}
		mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"],\n");
	}
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			mpq_out_str(fic,10,&(m(i,j).rep()));
			fprintf(fic,",");
		}
		mpq_out_str(fic,10,&(m(i,j).rep()));
		fprintf(fic,"]\n];\n");
	}
}

	template<template<typename T> class typmat >
void printmatfile(const typmat<RR> & m,char * name,FILE * fic)
{
	int i;
	fprintf(fic,"%s:=[",name);
	for(i=0;i<m.nrow-1;i++)
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			mpf_out_str(fic,10,NBDIGITS,(m(i,j).rep()));
			fprintf(fic,",");
		}
		mpf_out_str(fic,10,NBDIGITS,(m(i,j).rep()));
		fprintf(fic,"],\n");
	}
	{
		int j;
		fprintf(fic,"[");
		for(j=0;j<m.ncol-1;j++)
		{
			mpf_out_str(fic,10,NBDIGITS,(m(i,j).rep()));
			fprintf(fic,",");
		}
		mpf_out_str(fic,10,NBDIGITS,(m(i,j).rep()));
		fprintf(fic,"]\n];\n");
	}
}
#endif //SYNAPS_WITH_GMP

// read the 
//content of the file whose name is name
//INPUT : lists of polynomials in ALP format
//OUTPUT : lists of polynomials given appended with polynomials read 
//         in file <name>
//
	template <typename typP> 
void readfile(typP &toto,char *name)
{
	typedef typename typP::value_type pol;
	pol p;
	FILE *fic=fopen(name,"r");
	char * chaine=(char*)malloc(10000001);
	for (;fgets(chaine,10000000,fic)!=NULL;)//!cin.eof();)
	{
		printf("chainelue %s\n",chaine);fflush(stdout);
		toto.push_back(p=pol(chaine));
		std::cout<<"g pushe "<<p<<std::endl; 
	}
	fclose(fic);
	free(chaine);
}


__END_NAMESPACE_SYNAPS



