/**********************************************************************
 *    This file is part of the source code of the SYNAPS library.     
 *    Author(s): J.P. Pavone, GALAAD, INRIA                           
 *    $Id: simple.h,v 1.1 2005/07/11 10:03:57 jppavone Exp $
 **********************************************************************/
#ifndef SYNAPS_SOLVE_SBDSLV_STRGY_SIMPLE_HPP
#define SYNAPS_SOLVE_SBDSLV_STRGY_SIMPLE_HPP
//--------------------------------------------------------------------
#include <synaps/msolve/sbdslv/strgy/empty.h>
//--------------------------------------------------------------------
__BEGIN_NAMESPACE_SYNAPS
//--------------------------------------------------------------------
namespace sbdslv
{
  namespace strgy
  {
    template< class system, class _previous_ = empty<system> >
    struct simple : _previous_
    {
      typedef typename system::creal_t creal_t;
      typedef typename system::sz_t    sz_t;
      typedef typename system::interval_t interval_t;
      bool process( system * slv )
      {
	if ( !_previous_::process(slv) ) return false;
	slv->restrict();
	slv->project();
	return true;
      };
    };
  };
};
//--------------------------------------------------------------------
__END_NAMESPACE_SYNAPS
/********************************************************************/
#endif //
