#define USING_NAMESPACE_SYNAPS 1

#include <synaps/base/Seq.h>
#include "synaps/bignum.h"
#include "synaps/mpol.h"
#include "synaps/msolve/Newmac.h"

using std::cout;
using std::cin;
using std::endl;

//typedef RR coeff_t;
typedef double coeff_t;
typedef Monom<coeff_t,dynamicexp<unsigned> > mon;
                //numexp<'x',4,long long int > > mon ;
typedef MPol<coeff_t,DegLex,std::list<mon> >   POL;
typedef Seq<VectDse<std::complex<long double> > > sol_t;

int main (int argc, char **argv)
{
  cout.precision(15);
  std::list<POL>  L;
  L.push_back(POL("x0^2*x1-1"));
  L.push_back(POL("x0*x1^2-x0"));

  cout<<"Solutions:"<<endl<<solve(L,Newmac<coeff_t,sol_t>())<<endl;
}
