#ifndef SYNAPS_POINT_GRAPH_H
#define SYNAPS_POINT_GRAPH_H
#include <synaps/init.h>
#include <cstring>
__BEGIN_NAMESPACE_SYNAPS


template<class C>
struct static_neighborood : std::vector<C>
{
  typedef std::vector<C> mother;
  typedef typename mother::const_iterator const_iterator;
  typedef typename mother::iterator iterator;
};

// find + erase is better than remove in this case
template<class C> inline
void remove_neighbor( static_neighborood<C,false> & v, const C & key )
{
  typename static_neighborood<C>::iterator it = find(v.begin(),v.end(),key);
  if ( it != v.end() ) v.erase(it);
};

template<class C> inline
void remove_neighbor( static_neighborood<C,true> & v, const C & key )
{
  typename static_neighborood<C>::iterator it = lower_bound(v.begin(),v.end(),key);
  if ( !(key < *i) ) v.erase(it);
};

template<class C> inline
bool neighbor_exists( const static_neighborood<C,false> & v, const C & key )
{
  return find(v.begin(),v.end(),key) != v.end();
};

template<class C> inline
bool neighbor_exists( const static_neighborood<C,true> & v, const C & key )
{
  return binary_search(v.begin(),v.end(),key);
};

template<class C> inline
void insert_neighbor( static_neighborood<C,false> & v, const C & key )
{
  v.push_back(key);
};

template<class C> inline
void insert_neighbor( static_neighborood<C,true> & v, const C & key )
{
  v.insert(lower_bound(v.begin(),v.end(),key),key);
};


// vertex set implemented as a vector 
//        for static use => no suppression of vertex 
//        optional use of hashmap for optimising the exists function
template<class C, typename vertex_ref, bool hashmap>
struct static_vertex_set { 
  std::map<C,vertex_ref> map_;
};
template<class C, typename vertex_ref, bool hasmap >
void  insert_vertex( static_vertex_set<C,vertex_ref,hasmap> & v, const C & c, const vertex_ref & vref )
{
  
};

template<class C, typename vertex_ref > inline
void insert( hashmap_vertex_set<C,vertex_ref> & v, const C & key, const typename vertex_ref & ref )
{
  if ( v.vertices_[key].id_ > vertex_ref::
};

template<class C, typename vertex_ref > inline
void insert( vector_vertex_set<C,vertex_ref> & v, const C & key, const typename vertex_ref & ref )
{
  v.vertices_.push_back(vertex(c));
  v.back().id_ = ref;
};

template<class C>
struct map_vertex_set<C,true>
{
  std::map<C,int> 
  vertex_set() : index(0) {};
};

template<class C, bool oriented = false, bool ordered = false > 
struct static_graph
{
  typedef static_neighborood<vertex_ref,ordered> ngh_t;
  struct vertex {
    C     data_;
    ngh_t neighbors_;
    int id_;
    vertex( const C & x ) : data_(x) {};
  };
  
  std::vector<vertex> vertices_;
  

  vertex_ref insert( const C & c ) { insert(vertices_,vertices_.size()); };
  void insert_edge( vertex_ref a, vertex_ref b )
  {
    
  };

  void link( vertex_ref a, vertex_ref b )
  {
    if ( ! oriented )
      {
	if ( a < b )
	  insert_neighbor( vertices_[a].neighbors_, b );
	else 
	  insert_neighbor( vertices_[b].neighbors_, a );
      }
    else 
      insert(vertex_
  };

  inline 
  bool vertex_exists( const C & c )
  {
    
  };
  
};


template<class C, bool b> inline
typename static_graph<C,B>::vertex_ref insert( static_graph<C,B> & g, const C & c ) { g.insert(c); };
template<class C, bool b> inline

template<class C, bool b>

template<class point>
struct point_graph
{
  std::vector<point> vertex_data_;
  std::vector<edge>   edge_chunk_;

  link *            free_nodes_;
  vertex *          kline_;
  struct link { link * next; };
  
  struct evref { bool sw : 1; int ref : 31; };

  struct vertex 
  {  
    static const int _dimension_ = point::_dimension_;
    point position_;
    std::list<vertex*> neighborhood_;
    int right_reference_;
    int left_reference_;
  };

  suppress( neighborhood , const vertex * key );
  template<class fusion_function>
  void fusion( vertex * a, vertex * b )
  {
    fusion_function(a->data,b->data);
    kill(b, a->neighborood);
    kill(a, b->neighborood);
    
    neighborhood_resize( a, neighborhood_size(a) );
    
  };

  vertex * newnode( const point & p )
  {
    
    if ( free_nodes_ ) 
      {
	vertex * n = (vertex*)free_nodes_;
	new (n) vertex(p);
	n->self_reference_ = - n->self_reference_;
      }
    else
      {
	 
      };
  };

  int insert( const point & p )
  {
    return newnode(p)->self_reference_;
  };
  
  
  
};
__END_NAMESPACE_SYNAPS

#endif
