#ifndef SYNAPS_SHAPE_GAIA_QSEGMENT_H
#define SYNAPS_SHAPE_GAIA_QSEGMENT_H

#include <synaps/shape/gaia/lsegment.h>
#include <synaps/shape/gaia/qnode.h>

__BEGIN_NAMESPACE_SYNAPS

namespace gaia {
  
  struct lrnode
  {
    coord_t umin, umax, lmin, rmin, lmax, rmax;
    lrnode *rs, *ls;
    static lrnode * alloc( unsigned size );
    static lrnode * make( lrnode * data, unsigned size );
  };
  
  typedef lrnode * lrtree;
  
  struct qsegment : public lsegment
  {
    std::vector<qtree> trees;
    void scale_conflict( vector3 a[4], vector3 b[4], qtree qa, qtree qb );
    void make_box( rid_t id, qnode * q );
    qnode * make( rid_t id, coord_t vmin, coord_t vmax, lrnode * lr );
    inline unsigned size() const { return trees.size(); };
    inline qtree operator[]( unsigned i ) { return trees[i]; };
    double _qt;
    qsegment( const IParametricSurface * s, unsigned w, unsigned h  );
    ~qsegment(); 
    
    
  };
  
};
__END_NAMESPACE_SYNAPS

#endif






