#ifndef SYNAPS_SHAPE_GAIA_SAMPLE_H
#define SYNAPS_SHAPE_GAIA_SAMPLE_H

#include <synaps/shape/gaia/gaia.h>
#include <synaps/shape/interfaces/IParametricSurface.h>

__BEGIN_NAMESPACE_SYNAPS

namespace gaia
{
  struct sample
  {
    const IParametricSurface * m_psurf;
    double * m_uvals;
    double * m_vvals;
    coord_t  m_nrows;
    coord_t  m_ncols;
    vector3 * m_svals;
    sample( const IParametricSurface * s, int m, int n );
    ~sample();
    vector3 * base() const { return m_svals; };
    int nrows() const { return m_nrows; };
    int ncols() const { return m_ncols; };
    inline const double & uvalue( int i ) const { return m_uvals[i]; };
    inline const double & vvalue( int i ) const { return m_vvals[i]; };
  };

};

__END_NAMESPACE_SYNAPS
#endif
