#ifndef SYNAPS_SHAPE_PARAMETRICSURFACE_H
#define SYNAPS_SHAPE_PARAMETRICSURFACE_H

#include <synaps/shape/interfaces/IShape.h>
#include <synaps/shape/gmv/stream.h>

__BEGIN_NAMESPACE_SYNAPS

struct IParametricSurface : IShape
{
  typedef IShape base_t;

  virtual void range( double & umin, double & umax, double & vmin, double & vmax )               const = 0;
  virtual void eval ( double * p, double u, double   v )                                         const = 0;
  virtual void eval ( double * p, const double * uv, int n )                                     const = 0;
  virtual bool eval ( double * p, const double * u, const double * v, int m, int n )             const = 0;
  virtual bool sample( double * p, double * u, double * v, int m, int n )                        const = 0;
  virtual void setGrid( int m, int n ) = 0;
  //  virtual IParametricCurve * iso_u( double u )                                                   const = 0;
  //  virtual IParametricCurve * iso_v( double v )                                                   const = 0;
  //  IParametricSurface * gauss_map() const = 0;
};

IShape * intersect(  IParametricSurface * a,  IParametricSurface * b );
IShape * selfintersection( const IParametricSurface * s );
IGLGood * mesh( const IParametricSurface * ps, int m, int n );

__END_NAMESPACE_SYNAPS

#endif
