#ifndef SYNAPS_SHAPE_INTERFACES_INFOS_H
#define SYNAPS_SHAPE_INTERFACES_INFOS_H

#include <synaps/init.h>
#include <map>

__BEGIN_NAMESPACE_SYNAPS


struct CInterfaceInfo 
{
  CInterfaceInfo * base;
  static int   icount;
  const char * iname;
  int          iid;
  int          nreps;
  //  virtual CInterfaceInfo *base() const = 0;//{ return 0; };
};


template<class I> struct InterfaceInfo;
template<class I>
struct Interface { static InterfaceInfo<I> info; };

template<class I>
struct __interface_info__
{
  CInterfaceInfo * operator()() const { return & Interface<I>::info; };
};
template<>
struct __interface_info__< type::null_t >
{
  CInterfaceInfo * operator()() const { return 0; };

};

template<class I>
struct InterfaceInfo : CInterfaceInfo
{    
  InterfaceInfo()
  {
    this->iname  = SYNAPS::type::name<I>();
    this->iid   = CInterfaceInfo::icount++;
    this->nreps = 0;
    this->base  = __interface_info__<typename I::base_t>()();
    //& Interface<typename I::base_t>::info;
  };
  //  CInterfaceInfo * base() { return & Interface<typename I::base_t>::info; };
};



inline
std::ostream& operator<<( std::ostream & o, const CInterfaceInfo & iinfo )
{
  o << " interface name = " << iinfo.iname << std::endl;
  o << " interface id   = " << iinfo.iid   << std::endl;
  o << " implemented by " << iinfo.nreps << " types\n";
  return o;
};

struct IShape;
struct IGLGood;
struct IParametricSurface;
struct IBSplineSurface;
struct IRationalSurface;
struct IParametricCurve;
struct IRationalCurve;
struct IBSplineCurve;
struct IImplicitSurface;
struct IAlgebraicSurface;

//template<class Interface>
//int InterfaceInfoClass<Interface>::interface_id = Interfaces::instances_count++;
//int InterfaceInfoClass<Interface>::instance_count = 0;

__END_NAMESPACE_SYNAPS 

#endif 
