#include <iostream>
#include <synaps/shape/trees/bnode_base.h>

__BEGIN_NAMESPACE_SYNAPS

namespace trees
{
  int depth( bnode const * const  n )
  {
    if ( n ) 
      {
	if ( left(n) != right(n) ) return std::max( depth(left(n)), depth(right(n)) ) + 1; else return 1;
      };
    return 0;
  };

  void leaves( std::vector<bnode*>& s, bnode * n )
  {
    if ( n ) 
      {
	if ( left(n) != right(n)  ) {
	  leaves( s, left(n) );
	  leaves( s, right(n) );
	}
	else s.push_back( n );
      };
  };

  void infix( std::vector<bnode*>& s, bnode * n )
  {
    if ( n ) 
      {
	if ( left(n) != right(n) )
	  {
	    infix( s,left(n) );
	    s.push_back(n);
	    infix( s,right(n));
	  }
	else s.push_back(n);
      };
  };
  
  void prefix( std::vector<bnode*>& s, bnode * n )
  {
    if ( n )
      {
	s.push_back(n);
	if ( left(n) != right(n) )
	  {
	    prefix(s,left(n));
	    prefix(s,right(n));
	  }
      };
  };

  void postfix( std::vector<bnode*>& s, bnode * n )
  {
    if ( n )
      {
	if ( left(n) != right(n) )
	  {
	    postfix(s,left(n));
	    postfix(s,right(n));
	  };
	s.push_back(n);
      };
  };
  
  void nodes( std::vector<bnode*>& s, bnode * n )
  {
    if ( n ) 
      {
	s.push_back(n);
	if ( left(n) != right(n) )
	  {
	    nodes(s,left(n));
	    nodes(s,right(n));
	  };
      };
  };
  
  int size( bnode const * const n )
  {
    if ( n )
      if ( left(n) != right(n) ) return size(left(n))+size(right(n))+1;
      else return 1;
    return 0;
  };
};

