#ifndef SYNAPS_SHAPE_SSIQTS_H
#define SYNAPS_SHAPE_SSIQTS_H

#include <synaps/shape/interfaces/IParametricSurface.h>
#include <synaps/shape/base/fxv.h>
#include <iostream>

__BEGIN_NAMESPACE_SYNAPS


struct SSIQTS 
{
  typedef fxv<double,3> vector3;
  typedef double aabb3 [3][2];
  typedef double ipoint [7];

  int udeg;
  int vdeg;
  int m;
  
  struct sample
  {

    double  * m_uvals;
    double  * m_vvals;
    vector3 * m_svals;
    int       m_nrows;
    int       m_ncols;
    inline       vector3& operator[]( int i )       { return m_svals[i]; };
    inline const vector3& operator[]( int i ) const { return m_svals[i]; };
    sample( IParametricSurface * s, int m, int n );
    ~sample();
  };
  
  sample * smpa;
  sample * smpb;
  
  aabb3  * boxa;
  aabb3  * boxb;

  int * m_bcf;
  int * m_ecf;

  void cfprint( std::ostream& gpr, std::ostream& gpl );

  SSIQTS( IParametricSurface * srfa,  IParametricSurface * srfb, int n, int degu, int degv );
  ~SSIQTS();

};

__END_NAMESPACE_SYNAPS

#endif
