#ifndef SYNAPS_SHAPE_WRATIONALSURFACE_H
#define SYNAPS_SHAPE_WRATIONALSURFACE_H

#include <synaps/shape/wrappers/wrapper.h>
#include <synaps/shape/interfaces/IRationalSurface.h>
#include <synaps/shape/wrappers/WParametricSurface.h>

__BEGIN_NAMESPACE_SYNAPS

namespace rational_surface {};


template<class C, class R> inline
bool setRange( wrapper<R,IRationalSurface> & r, const C & umin, const C & umax, const C & vmin, const C & vmax    ) 
{ 
  using namespace rational_surface;
  return setRange(r.rep(),umin,umax,vmin,vmax);
};

template<class R>
void setEquations( wrapper<R,IRationalSurface> & s, 
		   const char * w, const char * x, const char * y, const char * z, 
		   const char * variables  )
{
  using namespace rational_surface;
  setEquations( s.rep(), w, x, y, z, variables );
};

template<class R>
struct wrapper<R,IRationalSurface> :  wrapper<R,IRationalSurface::base_t>
{
  bool setRange( double  umin, double umax, double  vmin, double  vmax )  
  { return ::setRange(this->rep(), umin,umax,vmin,vmax); };
  void setEquations( const char * w, const char * x, const char * y, const char *  z,
		     const char * variables )
  { ::setEquations(this->rep(),w,x,y,z,variables); }
};

__END_NAMESPACE_SYNAPS



#endif
