#ifndef SYNAPS_SHAPE_WSHAPE_H
#define SYNAPS_SHAPE_WSHAPE_H

#include <synaps/shape/interfaces/IShape.h>
#include <synaps/shape/interfaces/IParametricSurface.h>
#include <synaps/shape/interfaces/IParametricCurve.h>
#include <synaps/shape/gmv/stream.h>
#include <synaps/shape/base/fxv.h>
#include <synaps/shape/wrappers/wrapper.h>

__BEGIN_NAMESPACE_SYNAPS


template<class R>
IGLGood * mesh( const wrapper<R,IParametricSurface> & s );
template<class R>
IGLGood * mesh( const wrapper<R,IParametricCurve> & c );
//template<class R>
//IGLGood *  mesh( const wrapper<R,IAlgebraicSurface> & s );

namespace Shape {};
template<class R> 
IGLGood *  mesh( const wrapper<R,IShape> & s ) 
{
  using namespace Shape;
  return mesh(s.rep());
};

namespace Shape
{
  //  template<class R> inline
  //  IGLGood * mesh( const R & r ) { std::cout << "Shape::mesh\n"; return 0; };
};

template<class R> 
struct wrapper<R,IShape> : wrapper<R,IShape::base_t>
{
  static const char * __repname;
  static const char * __iname;
  IGLGood * mesh_; 
  IGLGood *& mesh_member() { return mesh_; };
  const char * repname() const { return __repname; };
  const char * iname () const { return __iname; };
  wrapper() : mesh_(0) {};
  void unconst () { 
    if ( mesh_ ) { delete mesh_; mesh_ = 0; };
  };
  ~wrapper() { 
    static int del = 0;
    if ( del == 0 ) { std::cout << "forward to R~\n"; del = 1; ((R*)this)->~R(); };
    del = 0;
  };
  
  IShape * make() const { return new R; };
  IGLGood * mesh() { 
    if ( ! mesh_ ) mesh_ = ::mesh(*((const R*)this));
    return mesh_;
  }
};

template<class R> const char * wrapper<R,IShape>::__repname = type::name<R>();
template<class R> const char * wrapper<R,IShape>::__iname   = type::name<typename R::base_t>();

__END_NAMESPACE_SYNAPS

#endif
