#ifndef SYNAPS_SHAPE_FACTORY_WRAPPER_H
#define SYNAPS_SHAPE_FACTORY_WRAPPER_H
#include <synaps/shape/interfaces/IShapeFactory.h>
#include <synaps/base/type.h>
#include <cstring>
#include <map>
__BEGIN_NAMESPACE_SYNAPS



struct shape_factory_map_ltstr
{
  bool operator()(const char* s1, const char* s2) const { return strcmp(s1, s2) < 0; }
};

typedef std::map< const char *, std::list< IShape * >, shape_factory_map_ltstr > shape_factory_map;

struct CShapeFactory: IShapeFactory
{
  shape_factory_map types;
  IShape * interface( const char * interface_name_, const char * representation_name_  );
  std::list<IShape *> representations( const char * interface_name_ ) ;
  void insert( IShape *  te );
  
};

template<class L>
struct WShapeFactoryFill;
template<>
struct WShapeFactoryFill< type::null_t >  {  WShapeFactoryFill( CShapeFactory & ){}; };
template< class A, class B > 
struct WShapeFactoryFill < type::tlist< A, B > > : WShapeFactoryFill<B>
{ WShapeFactoryFill( CShapeFactory & m ) : WShapeFactoryFill<B>(m) 
  { 
    //    IShape * tmp ;
    //    tmp = dynamic_cast<IShape*>(new A());
   m.insert(new A()); 
  };  
};
template< class List >
struct WShapeFactory : CShapeFactory  { WShapeFactory() { WShapeFactoryFill<List>(*this); }; };


__END_NAMESPACE_SYNAPS

#endif
