#include <synaps/shape/interfaces/IParametricSurface.h>
#include <synaps/shape/gaia/dsearch.h>
#include <synaps/shape/wrappers.h>

__BEGIN_NAMESPACE_SYNAPS

struct SelfIntersectionResult;
template<> struct interfaceof< SelfIntersectionResult > { typedef IShape T; };
struct SelfIntersectionResult : wrapper<SelfIntersectionResult,IShape>
{
  IGLGood * glg;
  SelfIntersectionResult(){};
  SelfIntersectionResult( int type, int nbv, int nbi ) 
  { glg = new IGLGood(type,nbv,nbi,false); };
  ~SelfIntersectionResult() { delete glg;};
};

IGLGood * mesh( const SelfIntersectionResult & r ) { return r.glg; };


IShape *  selfintersection( const IParametricSurface * surf )
{
  gaia::dsearch ds(surf,200,200);
  
  int nbv, nbi, a, i, c, s ;
  
  for ( nbv = 0, nbi = 0, c = 0; c < (int)ds.nbcurves; c++ )
    {
      s = ds.sizes[c]; 
      nbv += s;
      nbi += (s-2)*2+2;
    };
  
  SelfIntersectionResult * result = new SelfIntersectionResult(IGLGood::E_LINE,nbv,nbi);
  
  fxv<double,2> * prms = new fxv<double,2>[nbv];
  
  a = 0;
  for  ( c = 0; c < (int)ds.nbcurves; c++ )
    for ( int i = 0; i < (int)ds.sizes[c]; i++, a++ )
      prms[a] = ds.lefts[c][i];
  

  surf->eval(result->glg->vertices,(const double*)prms,nbv);
  
  int ci = 0;
  a = 0;
  for  ( c = 0; c < (int)ds.nbcurves; c++ )
    {
      for ( int i = 0; i < (int)ds.sizes[c]-1; i++, a++ )
	{
	  result->glg->indexes[ci]   = a;
	  result->glg->indexes[ci+1] = a+1;
	  ci += 2;
	};
      a++;
    };
  delete[] prms;
  return result;
};


__END_NAMESPACE_SYNAPS
