#include <synaps/shape/gmv/stream.h>
#include <algorithm>
__BEGIN_NAMESPACE_SYNAPS
namespace gmv
{
  
  /*  
  void uvsmp_off( float * src, unsigned m, unsigned n )
  {
  unsigned nfcs = (m-1)*(n-1);
  unsigned nvtx = m*n;
  unsigned nedg = nfcs*4;
  #define _ij_(i,j) (i)*n+j
  if ( m_binary )
      {
      fprintf(m_fd,"{ = OFF BINARY\n");
      unsigned * data = new unsigned [3+3*(m*n)+(2+4)*(m-1)*(n-1)];
      data[0] = m*n;
      data[1] = (m-1)*(n-1);
      data[2] = 4*data[1];
	float * pts = (float*)(data + 3);
	std::copy(src,src+3*m*n,pts);
	unsigned * idx = data + 3 + 3*m*n;
	for ( unsigned i = 0; i < m-1; i ++ )
	  for ( unsigned j = 0; j < n-1; j ++, idx += 6 )
	    {
	      idx[0] = 4;
	      idx[1] = i*n+j;
	      idx[2] = i*n+j+1;
	      idx[3] = (i+1)*n+j+1;
	      idx[4] = (i+1)*n+j;
	      idx[5] = 0;
	    };
	
	swab4(data,3+3*m*n+6*(m-1)*(n-1));
	fwrite(data,4,3+3*m*n+6*(m-1)*(n-1),m_fd);
	fprintf(m_fd,"}\n");
	delete[] data;
      }
    else
      {
	fprintf(m_fd," { = OFF\n");
	fprintf(m_fd,"%i %i %i\n", nvtx, nfcs, nedg );
	for ( unsigned i =0; i < m*n; i ++ )
	  fprintf(m_fd,"%f %f %f\n", (src+i*3)[0], (src+i*3)[1], (src+i*3)[2] );
	for ( unsigned i = 0; i < m-1; i ++ )
	  for ( unsigned  j = 0; j < n-1; j++ )
	    fprintf(m_fd,"%i %i %i %i %i\n",// %i %i %i \n",
		    4, _ij_(i,j),_ij_(i+1,j),_ij_(i+1,j+1),_ij_(i,j+1));//,  123, 123, 255 );
	fprintf(m_fd," }\n");
      };
  };
  */

  void stream::uvsmp( const float * src, unsigned m, unsigned n, float * colors )
  {
    //    unsigned nfcs = (m-1)*(n-1);
    //    unsigned nvtx = m*n;
    //    unsigned nedg = nfcs*4;
    #define _ij_(i,j) (i)*n+j
    if ( m_binary )
      {
	if ( colors == 0 )
	  {
	    fprintf(m_fd,"{ = MESH BINARY\n");
	    unsigned * data = new unsigned [2+3*(m*n)];
	    data[0] = m;
	    data[1] = n;
	    float * pts = (float*)(data+2);
	    std::copy(src,src+3*m*n,pts);
	    swab4(data,2+3*m*n);
	    fwrite(data,4,2+3*m*n,m_fd);
	    fprintf(m_fd,"}\n");
	    delete[] data;
	  }
	else
	  {
	    fprintf(m_fd,"{ = CMESH BINARY\n");
	    unsigned * data = new unsigned[2+7*(m*n)];
	    data[0] = n;
	    data[1] = m;
	    float * pts = (float*)(data+2);
	    unsigned c = 0;
	    for ( unsigned i = 0; i < m*n; i ++, c += 7 )
	      {
		pts[c] = src[3*i];
		pts[c+1] = src[3*i+1];
		pts[c+2] = src[3*i+2];
		pts[c+3] = colors[4*i];
		pts[c+4] = colors[4*i+1];
		pts[c+5] = colors[4*i+2];
		pts[c+6] = colors[4*i+3];
	      };
	    swab4(data,2+7*m*n);
	    fwrite(data,4,2+7*m*n,m_fd);
	    fprintf(m_fd,"}\n");
	    delete[] data;
	  }
      }
    else
      {
	    fprintf(m_fd," { = MESH\n");
	    fprintf(m_fd,"%i %i\n", m, n );
	    for ( unsigned i = 0; i < m*n; i ++ )
	      fprintf(m_fd,"%f %f %f\n", (src+i*3)[0], (src+i*3)[1], (src+i*3)[2] );
	    fprintf(m_fd," }\n");
	  };
      };

  
  void stream::graph( float * src, unsigned m, unsigned n, float * colors )
  {
    //    unsigned nfcs = (m-1)*(n-1);
    //    unsigned nvtx = m*n;
    //    unsigned nedg = nfcs*4;
    #define _ij_(i,j) (i)*n+j
    
    if ( colors == 0 )
      {
	fprintf(m_fd,"{ = ZMESH BINARY\n");
	unsigned * data = new unsigned [2+(m*n)];
	data[0] = n;
	data[1] = m;
	float * pts = (float*)(data+2);
	std::copy(src,src+m*n,pts);
	swab4(data,2+m*n);
	fwrite(data,4,2+m*n,m_fd);
	fprintf(m_fd,"}\n");
	delete[] data;
      }
    else
      {
	fprintf(m_fd,"{ = CZMESH BINARY\n");
	unsigned * data = new unsigned[2+5*(m*n)];
	data[0] = n;
	data[1] = m;
	float * pts = (float*)(data+2);
	unsigned c = 0;
	for ( unsigned i = 0; i < m*n; i ++, c += 5 )
	  {
	    pts[c] = src[i];
	    pts[c+1] = colors[4*i];
	    pts[c+2] = colors[4*i+1];
	    pts[c+3] = colors[4*i+2];
	    pts[c+4] = colors[4*i+3];
	  };
	swab4(data,2+5*m*n);
	fwrite(data,4,2+5*m*n,m_fd);
	fprintf(m_fd,"}\n");
	delete[] data;
      }
  }
};

__END_NAMESPACE_SYNAPS
