#include <synaps/shape/interfaces/IShape.h>
#include <synaps/shape/interfaces/IBSplineSurface.h>
#include <synaps/shape/interfaces/IRationalSurface.h>
#include <synaps/shape/interfaces/IImplicitSurface.h>
#include <synaps/shape/interfaces/IBSplineCurve.h>
#include <synaps/shape/interfaces/IRationalCurve.h>


template< class I, class R>
struct ViewInfo : ViewInfo<typename I::base_t ,R>
{
  int rep_id;
  ViewInfo() { 
    std::cout << type::name< ViewInfo< I, R>  > () << std::endl;
    rep_id = Interface<I>::info.nreps++;};
};


static int rep_counter__ = 0;

template<class R> struct RepInfo
{
  int          rid;
  const char * repname ;
  RepInfo()
  {
    repname = type::name<R>();
    rid = rep_counter__ ++;
    std::cout << " rep_counter__ = " << rep_counter__ << std::endl;
  };
};

template<class R>
std::ostream & operator<<( std::ostream & o, const RepInfo<R> & i )
{
  o << " [RepInfo] \n";
  o << "\tname = " << i.repname << std::endl;
  o << "\trid  = " << i.rid << std::endl;
  return o;
};
template<class R> struct Rep { static RepInfo<R> info; };
template<class R> RepInfo<R>  Rep<R>::info;
template<class R>
struct ViewInfo<SYNAPS::type::null_t, R> 
{
  ViewInfo() 
  {
    volatile int c = Rep<R>::info.rid;
    std::cout << type::name<R>() << std::endl;
    std::cout << c << std::endl;
  };
};







template<class I, class R>
struct View 
{
  static  ViewInfo<I,R> info;
  //  typedef ViewImpl<I,R> type;
};

template<class I, class R> ViewInfo<I,R> View<I,R>::info;



template< class R> 
struct View < SYNAPS::type::null_t,R > {};


struct bspline_surface_impl  {};
struct rational_surface_impl {};
struct implicit_surface_impl {};
struct rational_curve_impl   {};
struct bspline_curve_impl    {};

template<class R>
std::ostream & operator<<( std::ostream & o, const Rep<R> & r )
{
  o << Rep<R>::info << std::endl;
  return o;
};


int main()
{

  std::cout << View<IBSplineSurface,bspline_surface_impl>::info.rep_id << std::endl;
  std::cout << View<IRationalSurface,rational_surface_impl>::info.rep_id << std::endl;
  std::cout << View<IImplicitSurface,implicit_surface_impl>::info.rep_id << std::endl;
  std::cout << View<IRationalCurve,rational_curve_impl>::info.rep_id << std::endl;
  std::cout << View<IBSplineCurve,bspline_curve_impl>::info.rep_id << std::endl;
  std::cout << " --------------------------------------------\n";
  
  std::cout << Rep<bspline_curve_impl>::info << std::endl;
  std::cout << Rep<rational_surface_impl>::info << std::endl;
  

  std::cout << Interface<IParametricCurve>::info << std::endl;
  std::cout << Interface<IRationalCurve>::info << std::endl;
  
  CInterfaceInfo * a = & Interface<IRationalCurve>::info ;
  std::cout << *(a->base) << std::endl;
  std::cout << *(a->base->base) << std::endl;
  std::cout << "----\n";
  

  
};


// struct ICommand 
// {
//   virtual const char * name()  = 0;
//   virtual         int arity()  = 0;
//   virtual IShape * launch ( IShape ** )    = 0;
// };

// template<int n>
// struct CommandLaunchImpl;

// template<class CommandName, Prototype,  int n>
// struct CommandLaunchImpl;


// template<>  CommandLaunch< cmd_intersect, proto< IParametricSurface, IParametricSurface > >
// {
//   return 
// };

// template<class cmd>
// struct CommandImpl<2> : ICommand
// { IShape * launch( IShape ** shapes )  { return cmd[repname()][repname()](  shapes[0], shapes[1] ); }; };


// template<class CommandName, class Prototype >
// struct CommandImpl : 
//   CommandLaunchImpl< CommandName, arity_ >
// {
//   const char * name() const { return CommandName::name_; };
//   int arity () const { return type::ListLength< prototype >::V; };
//   void launch()
//   {
    
//   };
// };


// template<class CommandName, class ListOfPrototypes >
// struct action
// {
//   ICommand names[ length< ListOfPrototypes >::V ]
// };


// action< intersect, 
// 	protolist< proto< IShape, IParametricSurface, IParametricSurface >,
// 		   proto< IShape, IParametricCurve  , IParametricCurve >, 
// 		   proto< IShape, IParametricCurve  , IParametricSurface > >


// intersect( IParametricSurface*, IParametricSurface* )



// X,Y
