/* SISL - SINTEF Spline Library version 4.4.                              */
/* Definition and interrogation of NURBS curves and surface.              */
/* Copyright (C) 1978-2005, SINTEF ICT, Applied Mathematics, Norway.      */

/* This program is free software; you can redistribute it and/or          */
/* modify it under the terms of the GNU General Public License            */
/* as published by the Free Software Foundation version 2 of the License. */

/* This program is distributed in the hope that it will be useful,        */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License      */
/* along with this program; if not, write to the Free Software            */
/* Foundation, Inc.,                                                      */
/* 59 Temple Place - Suite 330,                                           */
/* Boston, MA  02111-1307, USA.                                           */

/* Contact information: e-mail: tor.dokken@sintef.no                      */
/* SINTEF ICT, Department of Applied Mathematics,                         */
/* P.O. Box 124 Blindern,                                                 */
/* 0314 Oslo, Norway.                                                     */

/* SISL commercial licenses are available for:                            */
/* - Building commercial software.                                        */
/* - Building software whose source code you wish to keep private.        */


#include "copyright.h"



#define S1521

#include "sislP.h"

#if defined(SISLNEEDPROTOTYPES)
SISLCurve* 
s1521(SISLCurve *pc,int *jstat)
#else
SISLCurve* s1521(pc,jstat)
     SISLCurve *pc;
     int   *jstat;
#endif
{
  int in;                
  int ik;                
  int ikind;             
  int idim;              
  double *et;            
  double *ecoef;         
  double *rcoef=SISL_NULL;    
  SISLCurve *ratpc=SISL_NULL; 
  int i,j,J,jj;          
 
  *jstat=0;
  in    = pc -> in;
  ik    = pc -> ik;
  ikind = pc -> ikind;
  idim  = pc -> idim;
  et    = pc -> et;
  ecoef = pc -> ecoef;
  
  if (ikind == 2 || ikind == 4)
  {
      *jstat=1;

      

      rcoef = pc -> rcoef;
  }
  else
  {
      
    
      rcoef = newarray(in*(idim+1),DOUBLE);
      if(rcoef == SISL_NULL) goto err101;
    
      for(i=0, j=0, J=0; i<in; i++, j++)
      {
          for (jj=0; jj<idim; jj++, j++, J++) 
          {
              rcoef[j]=ecoef[J];
          }
    
          rcoef[j]=(double)1.0;
      } 
      ikind++;
  }

  

  ratpc=newCurve(in,ik,et,rcoef,ikind,idim,1);
  if(ratpc == SISL_NULL) goto err101;


  
  
  goto out;
  
  
  
 err101: *jstat = -101;
  s6err("s1521",*jstat,0);
  goto out;
  
 out: 
  
  
  if(pc->ikind == 1 || pc->ikind == 3)
    if (rcoef != SISL_NULL) freearray(rcoef);
  
  return ratpc;
}

