#include <string>
#include <synaps/mpol/xml.h>
#include <synaps/topology/TopSbdCurve3d.h>
#include <synaps/base/io/geomview.h>
#include <synaps/base/io/axel.h>
typedef std::string   str_t;
int main(int argc, char** argv) 
{
  MPol<double> p;

  //    p1("x^4+y^4+z^4-4*x^2-4*y^2*z^2-4*y^2-4*z^2*x^2-4*z^2-4*x^2*y^2+20.7846*x*y*z+1",
  //       Variables("x y z")),
  //    p3("x^2+y^2+z^2-1", Variables("x y z")),
  //    p2("4*x^3-8*x-8*x*z^2-8*x*y^2+20.7846*y*z", Variables("x y z"));

  
  std::ifstream in(argv[1],std::ios::in);
  if(in.good())
    {
      unsigned N=0;
      for(unsigned c=2;c<argc;c++)
	{
	  if(str_t(argv[c])==str_t("-n"))
	    {
	      c++; N=atoi(argv[c]);
	    }
	}
      std::vector<MPol<double> > L;
      while(xml::read(in,p,Variables("x y z")))
	{
	  L.push_back(p);   
	  std::cout<<p<<std::endl;
	}
      topology::point_graph<double> g;
      topology::assign(g,L[0],L[1],TopSbdCurve3d<double>(), -3.0,3.2,-3.1,3.01,-3.02, 3.3);	
      geomview::ostream vw("tmp.axl");vw<<g;vw.view(); 
    }
}
