/********************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 *   $Id: horner.h,v 1.1 2005/07/11 08:12:26 mourrain Exp $
 ********************************************************************/
#ifndef SYNAPS_UPOL_HORNER_H
#define SYNAPS_UPOL_HORNER_H
/********************************************************************/

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

namespace upol {

	template<class C> struct horner: public upol::rep<C>
	{

		typedef typename upol::rep<C>::size_type size_type;
		typedef typename upol::rep<C>::iterator iterator;
		typedef typename upol::rep<C>::const_iterator const_iterator;
		typedef typename upol::rep<C>::const_reverse_iterator const_reverse_iterator;
		typedef typename upol::rep<C>::reverse_iterator reverse_iterator;

		horner(): upol::rep<C>() {}
		horner(size_type s, AsSize mth): upol::rep<C>(s,mth) {}
		horner(size_type s, C *t): upol::rep<C>(s,t){}
		horner(C* b, C *e): upol::rep<C>(b,e) {}
		horner(const horner<C> & p): upol::rep<C>(p){};
	};

}

__END_NAMESPACE_SYNAPS

/********************************************************************/
#endif // SYNAPS_UPOL_HORNER_H
