
#include "synaps/bignum.h"
#include "synaps/upol.h"
#include "synaps/upol/SturmSeq.h"


using std::cout;
using std::cin;
using std::endl;

typedef double XX;
typedef UPolDse<XX> Upol;

int main (int argc,char**argv)
{
  Upol p("5*x^4-30*x^3+2*x^2-x+2");

  SturmSeq<XX> s(p,diff(p),STD());
  cout <<s<<endl;

  SturmSeq<XX> s1(p,diff(p),HABICHT());
  cout <<s1<<endl;

  SturmSeq<XX> s2(p,diff(p),EUCLIDEAN());
  cout <<s2<<endl;

  SturmSeq<XX> s3(p,diff(p),REDUCED());
  cout <<s3<<endl;

  SturmSeq<XX> s4(p,diff(p),SUBRES());
  cout <<s4<<endl;

  cout <<variation(s1,double(0))<<endl;
  cout <<variation(s2,double(2))<<endl;

  //  cout << Solve(p, ALG_STURM<XX>())<<endl;

}

