
#include "synaps/linalg/rep1d.h"
#include "synaps/bignum.h"
#include "synaps/upol.h"

typedef ZZ C;
//typedef UPolDse<ZZ> Pol;
typedef UPolDse<ZZ,linalg::rep1d<ZZ> > Pol;

__BEGIN_NAMESPACE_SYNAPS

namespace linalg {
  void checkdegree(rep1d<ZZ> & r)
  {
    int l = r.size();
    while(l >0 && (r[l-1]==0)) {l--;}    
    if(l>=0)   r.resize(l);
  }
}

__END_NAMESPACE_SYNAPS



int main (int argc, char **argv)
{
  using std::cout;
  using std::cin;
  using std::endl;


  Pol p0("x0^2+x0+1;");
  cout<<"p0 ="<<p0<<endl;
  cout<<"p0+1 ="<<(p0+1)<<endl;
  cout<<"1-p0 ="<<(1-p0)<<endl;

  C u1[]={2,0,-1,1};
  Pol p1(u1,u1+4);
  cout<<"p1 ="<<p1<<endl;
  cout<<"p1(1)     ="<<UPOLDAR::eval_horner(p1,C(1))<<endl;  
  cout<<"p0((0,1)) ="<<p0(std::complex<C>(0,1))<<endl;  

  Pol p2(p0+p1);         cout<<p2<<endl;
  p2 =p0-p1;             cout<<p2<<endl;
  p2 =p0*p1;             cout<<p2<<endl;
  p2+=p1-p0;             cout<<p2<<endl; 
  p2 =p1; p2*=p0;        cout<<p2<<endl;
  p2+=(p1-p0)*(p1-p0*2); cout<<p2<<endl;
  p2 =p0-(p0+p1);        cout<<p2<<endl;
  p2 =p0 +p1*2;          cout<<p2<<endl;
  p2 =(p1+p0)*(p1-p0*2); cout<<p2<<endl;
  p2*=C("12143154132451234512345552414213"); cout<<p2<<endl;
  p2/=C(3);  cout<<p2<<endl;
  
  //Quotient for the Euclidean division
  p2=p1/p0;             cout<<p2<<endl;
  //Remainder for the Euclidean division
  p2=p1%p0;             cout<<p2<<endl;
  //  p1%=p0;               cout<<p1<<endl;

  p2=p1*2;             cout<<p2<<endl;
  p2=p1/2;             cout<<p2<<endl;
  return 0;
}
