/** \example Algebraic.cc **/
#include <synaps/upol.h>
#include <synaps/arithm/gmp.h>
#include <synaps/usolve/Algebraic.h>
typedef Algebraic<ZZ>::root_t root_t;

int main()
{
  using std::cout;
  using std::endl;

  UPolDse<ZZ> 
    p1("2*x^7+3*x^6+2*x^5+1*x^4-1*x^3-2*x^2-3*x+1"),
    p2("x^4-3*x^3+2*x^3-2*x^2-5*x+10"),
    p3("x^4-3*x^3+2*x^3-2*x^2-5*x+9");

  root_t 
    alpha= solve(p1,Algebraic<ZZ>(),1),
    beta = solve(p2,Algebraic<ZZ>(),0);

  cout<<"alpha: "<<alpha<<endl;
  //| root_of( 2*x^7+3*x^6+2*x^5+1*x^4-1*x^3-2*x^2-3*x+1, 1)
  //|  in [ 0,5/8 ], approx = 0.278212

  cout<<"beta : "<<beta <<endl;
  //| root_of( 1*x^4-1*x^3-2*x^2-5*x+10, 0 )
  //|  in [ 0,559/342 ], approx = 1.43343

  cout<<(alpha<beta)<<endl;
  //| 1

  cout <<sign_at(p1,beta)<<endl;
  //| 1

  cout <<sign_at(p2,beta)<<endl;
  //| 0

  cout <<sign_at(p3,beta)<<endl;
  //| -1
}
