/** \example BzSolver.cc **/
#include <synaps/upol.h>
#include <synaps/arithm/QQ.h>
#include <synaps/usolve/bezier/SlvBzStd.h>
#include <synaps/usolve/bezier/IslBzStd.h>
#include <synaps/usolve/bezier/SlvRkw.h>
int main()
{
  using std::cout; using std::endl;

  UPolDse<ZZ> P("2*x0^7+3*x0^6+2*x0^5+1*x0^4-1*x0^3-2*x0^2-3*x0+1");
  cout <<"Testing: "<<P<<endl;
  //| Testing: 2*x^7+3*x^6+2*x^5+1*x^4-1*x^3-2*x^2-3*x+1

  cout <<solve(P,SlvBzStd<double,double>(1e-6))<<endl;
  //| -1.35142, 0.278212, 0.880286

  cout <<solve(P,IslBzStd<double,double>(1e-6))<<endl;
  //| [ -1.35143,-1.35142 ], [ 0.278212,0.278213 ], 
  //| [ 0.880286,0.880287 ]

  cout << solve(P,SlvRkw<double>(1e-6)) <<endl;
  //| 0.278212
}
