


#ifndef SYNAPS_AK_GLOBAL_FUNCTIONS_4_H
#define SYNAPS_AK_GLOBAL_FUNCTIONS_4_H

#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template < class AK,
	   class OutputIterator >
inline
OutputIterator
solve( const typename AK::Polynomial_2_2 & f1,
       const typename AK::Polynomial_2_2 & f2,
       OutputIterator res )
{
  return AK().solve_object()(f1, f2, res);
}


template < class AK >
inline
typename AK::Polynomial_for_circles_2_2
construct_polynomial_2_2( const typename AK::RT& c5, const typename AK::RT& c4,
			  const typename AK::RT& c3, const typename AK::RT& c2,
			  const typename AK::RT& c1, const typename AK::RT& c0)
{
  return AK().construct_polynomial_2_2_object()(c5, c4, c3, c2, c1, c0);
}


template < class AK >
inline
int 
construct_sign_at(const typename AK::Polynomial_2_2& f,
		  const typename AK::Root_of_4& rx,
		  const typename AK::Root_of_4& ry)
{
  return AK().sign_at_object()(f, rx, ry);
}


__END_NAMESPACE_SYNAPS

#endif  // SYNAPS_AK_GLOBAL_FUNCTIONS_4_H
