// Copyright (c) 2003  INRIA Sophia-Antipolis (France) and
//                     Department of Informatics and Telecommunications
//                     University of Athens (Greece).
// All rights reserved.
//
// Authors : Elias P. TSIGARIDAS <et@di.uoa.gr>

// Partially supported by INRIA's project "CALAMATA", a
// bilateral collaboration with National Kapodistrian University of
// Athens.
// Partially supported by the IST Programme of the EU as a Shared-cost
// RTD (FET Open) Project under Contract No  IST-2000-26473
// (ECG - Effective Computational Geometry for Curves and Surfaces)


#ifndef ROOT_OF_KERNEL_AUTO_RESULT_LENGTH_3_HH
#define ROOT_OF_KERNEL_AUTO_RESULT_LENGTH_3_HH

#include "Auto_Results.h"
#include <synaps/base/comparison.h>

__ALGEBRAIC_BEGIN_NAMESPACE


class Result_length_3 {
        typedef std::map<int,int> MapResult;
	typedef MapResult::iterator MapResult_iter;
	static bool initialize;
	static void set_default_values();
  static MapResult map_S0_p2q2;
  static MapResult map_S0_p1q1;
  static MapResult map_S1_p2q2;
  static MapResult map_S1_p1q1;
  static MapResult map_S2;

	public:

	Result_length_3();

	Comparison_result on_S0_p2q2(int where);
        Comparison_result on_S0_p1q1(int where);
        Comparison_result on_S1_p2q2(int where);
        Comparison_result on_S1_p1q1(int where);
        Comparison_result on_S2(int where);

}; // end of Class

__ALGEBRAIC_END_NAMESPACE

#endif // ROOT_OF_KERNEL_AUTO_RESULT_LENGTH_3_HH




