/********************************************************************
 *   This file is part of the source code of the SYNAPS library
 *   Author(s): B. Mourrain, GALAAD, INRIA
 *   History:
 *     The Rockwood method for computing the first positive real root added.
 *   $Id: Bezier.h,v 1.1 2005/09/28 06:30:41 mourrain Exp $
 *********************************************************************/
/** \file                                                           **/
//--------------------------------------------------------------------
#ifndef synaps_solve_bezier_Bezier_H
#define synaps_solve_bezier_Bezier_H
//--------------------------------------------------------------------
__BEGIN_NAMESPACE_SYNAPS
struct Std {};
//--------------------------------------------------------------------
/** Class specifying the parameters of the Bezier subdivision algorithm.
    The default precision is \c 1e-6. The default type of coefficients \c C
    is \c double.
**/
template<class C=double, class T = Std, class X = C>
struct Bezier
{
  C eps;
  Bezier():eps(1.e-6) {}
  Bezier(const C& e):eps(e) {}
  Bezier(const Bezier & mth): eps(mth.eps) {}

};
/********************************************************************/
__END_NAMESPACE_SYNAPS 
#endif // SYNAPS_SOLVE_BEZIER1D_H

