// Copyright (c) 2003  INRIA Sophia-Antipolis (France) and
//                     Department of Informatics and Telecommunications
//                     Univeristy of Athens (Greece).
// All rights reserved.
//
// Authors : Elias P. TSIGARIDAS <et@di.uoa.gr>

// Partially supported by INRIA's project "CALAMATA", a
// bilateral collaboration with National Kapodistrian University of
// Athens.
// Partially supported by the IST Programme of the EU as a Shared-cost
// RTD (FET Open) Project under Contract No  IST-2000-26473
// (ECG - Effective Computational Geometry for Curves and Surfaces)


#include <synaps/usolve/algebraic/comparison/auto/Auto_Results.h>
#include <synaps/usolve/algebraic/comparison/auto/Result_length_6.h>


__ALGEBRAIC_BEGIN_NAMESPACE

bool Result_length_6::initialize = false;

Result_length_6::MapResult Result_length_6::map_S0_p2q2;
Result_length_6::MapResult Result_length_6::map_S0_p1q1;
Result_length_6::MapResult Result_length_6::map_S1_p2q2;
Result_length_6::MapResult Result_length_6::map_S1_p1q1;
Result_length_6::MapResult Result_length_6::map_S2_p2q2;
Result_length_6::MapResult Result_length_6::map_S2_p1q1;
Result_length_6::MapResult Result_length_6::map_S3_p2q2;
Result_length_6::MapResult Result_length_6::map_S3_p1q1;
Result_length_6::MapResult Result_length_6::map_S4_p2q2;
Result_length_6::MapResult Result_length_6::map_S4_p1q1;
Result_length_6::MapResult Result_length_6::map_S5;



	Comparison_result
Result_length_6::on_S0_p2q2(int where)
{
	MapResult_iter it;
	it = map_S0_p2q2.find(where);
	if (it != map_S0_p2q2.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S0_p1q1(int where)
{
	MapResult_iter it;
	it = map_S0_p1q1.find(where);
	if (it != map_S0_p1q1.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S1_p2q2(int where)
{
	MapResult_iter it;
	it = map_S1_p2q2.find(where);
	if (it != map_S1_p2q2.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S1_p1q1(int where)
{
	MapResult_iter it;
	it = map_S1_p1q1.find(where);
	if (it != map_S1_p1q1.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S2_p2q2(int where)
{
	MapResult_iter it;
	it = map_S2_p2q2.find(where);
	if (it != map_S2_p2q2.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S2_p1q1(int where)
{
	MapResult_iter it;
	it = map_S2_p1q1.find(where);
	if (it != map_S2_p1q1.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S3_p2q2(int where)
{
	MapResult_iter it;
	it = map_S3_p2q2.find(where);
	if (it != map_S3_p2q2.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S3_p1q1(int where)
{
	MapResult_iter it;
	it = map_S3_p1q1.find(where);
	if (it != map_S3_p1q1.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S4_p2q2(int where)
{
	MapResult_iter it;
	it = map_S4_p2q2.find(where);
	if (it != map_S4_p2q2.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S4_p1q1(int where)
{
	MapResult_iter it;
	it = map_S4_p1q1.find(where);
	if (it != map_S4_p1q1.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}

	Comparison_result
Result_length_6::on_S5(int where)
{
	MapResult_iter it;
	it = map_S5.find(where);
	if (it != map_S5.end())
		return to_CR(it->second);
	else
		return UNKNOWN;
}



 void Result_length_6::set_default_values()
{
	map_S0_p1q1       = MapResult(); 
	map_S0_p1q1[   0] = EQUAL;
	map_S0_p1q1[   3] = EQUAL;

	map_S3_p2q2       = MapResult(); 
	map_S3_p2q2[  17] = SMALLER;
	map_S3_p2q2[  34] = SMALLER;

	map_S3_p2q2[  93] = LARGER;
	map_S3_p2q2[ 110] = LARGER;

	map_S3_p1q1       = MapResult(); 
	map_S3_p1q1[  65] = SMALLER;
	map_S3_p1q1[  69] = SMALLER;
	map_S3_p1q1[  81] = SMALLER;
	map_S3_p1q1[  98] = SMALLER;
	map_S3_p1q1[ 114] = SMALLER;
	map_S3_p1q1[ 118] = SMALLER;
	map_S3_p1q1[ 130] = SMALLER;
	map_S3_p1q1[ 138] = SMALLER;
	map_S3_p1q1[ 177] = SMALLER;
	map_S3_p1q1[ 185] = SMALLER;

	map_S3_p1q1[  70] = LARGER;
	map_S3_p1q1[  78] = LARGER;
	map_S3_p1q1[ 117] = LARGER;
	map_S3_p1q1[ 125] = LARGER;
	map_S3_p1q1[ 137] = LARGER;
	map_S3_p1q1[ 141] = LARGER;
	map_S3_p1q1[ 157] = LARGER;
	map_S3_p1q1[ 174] = LARGER;
	map_S3_p1q1[ 186] = LARGER;
	map_S3_p1q1[ 190] = LARGER;

	map_S4_p2q2       = MapResult(); 
	map_S4_p2q2[   2] = SMALLER;
	map_S4_p2q2[  10] = SMALLER;
	map_S4_p2q2[  38] = SMALLER;
	map_S4_p2q2[  42] = SMALLER;
	map_S4_p2q2[  50] = SMALLER;
	map_S4_p2q2[  54] = SMALLER;
	map_S4_p2q2[ 193] = SMALLER;
	map_S4_p2q2[ 197] = SMALLER;
	map_S4_p2q2[ 209] = SMALLER;
	map_S4_p2q2[ 225] = SMALLER;
	map_S4_p2q2[ 229] = SMALLER;
	map_S4_p2q2[ 233] = SMALLER;
	map_S4_p2q2[ 237] = SMALLER;
	map_S4_p2q2[ 241] = SMALLER;
	map_S4_p2q2[ 249] = SMALLER;
	map_S4_p2q2[ 257] = SMALLER;
	map_S4_p2q2[ 261] = SMALLER;
	map_S4_p2q2[ 277] = SMALLER;
	map_S4_p2q2[ 281] = SMALLER;
	map_S4_p2q2[ 305] = SMALLER;
	map_S4_p2q2[ 313] = SMALLER;
	map_S4_p2q2[ 450] = SMALLER;
	map_S4_p2q2[ 458] = SMALLER;
	map_S4_p2q2[ 466] = SMALLER;
	map_S4_p2q2[ 470] = SMALLER;
	map_S4_p2q2[ 474] = SMALLER;
	map_S4_p2q2[ 478] = SMALLER;
	map_S4_p2q2[ 482] = SMALLER;
	map_S4_p2q2[ 498] = SMALLER;
	map_S4_p2q2[ 502] = SMALLER;

	map_S4_p2q2[   9] = LARGER;
	map_S4_p2q2[  13] = LARGER;
	map_S4_p2q2[  29] = LARGER;
	map_S4_p2q2[  33] = LARGER;
	map_S4_p2q2[  37] = LARGER;
	map_S4_p2q2[  41] = LARGER;
	map_S4_p2q2[  45] = LARGER;
	map_S4_p2q2[  53] = LARGER;
	map_S4_p2q2[  61] = LARGER;
	map_S4_p2q2[ 198] = LARGER;
	map_S4_p2q2[ 206] = LARGER;
	map_S4_p2q2[ 230] = LARGER;
	map_S4_p2q2[ 234] = LARGER;
	map_S4_p2q2[ 250] = LARGER;
	map_S4_p2q2[ 254] = LARGER;
	map_S4_p2q2[ 262] = LARGER;
	map_S4_p2q2[ 270] = LARGER;
	map_S4_p2q2[ 274] = LARGER;
	map_S4_p2q2[ 278] = LARGER;
	map_S4_p2q2[ 282] = LARGER;
	map_S4_p2q2[ 286] = LARGER;
	map_S4_p2q2[ 302] = LARGER;
	map_S4_p2q2[ 314] = LARGER;
	map_S4_p2q2[ 318] = LARGER;
	map_S4_p2q2[ 457] = LARGER;
	map_S4_p2q2[ 461] = LARGER;
	map_S4_p2q2[ 469] = LARGER;
	map_S4_p2q2[ 473] = LARGER;
	map_S4_p2q2[ 501] = LARGER;
	map_S4_p2q2[ 509] = LARGER;

	map_S4_p1q1       = MapResult(); 
	map_S4_p1q1[   1] = SMALLER;
	map_S4_p1q1[   5] = SMALLER;
	map_S4_p1q1[  21] = SMALLER;
	map_S4_p1q1[  25] = SMALLER;
	map_S4_p1q1[  49] = SMALLER;
	map_S4_p1q1[  57] = SMALLER;
	map_S4_p1q1[  73] = SMALLER;
	map_S4_p1q1[  77] = SMALLER;
	map_S4_p1q1[  85] = SMALLER;
	map_S4_p1q1[  89] = SMALLER;
	map_S4_p1q1[  97] = SMALLER;
	map_S4_p1q1[ 101] = SMALLER;
	map_S4_p1q1[ 105] = SMALLER;
	map_S4_p1q1[ 109] = SMALLER;
	map_S4_p1q1[ 113] = SMALLER;
	map_S4_p1q1[ 121] = SMALLER;
	map_S4_p1q1[ 134] = SMALLER;
	map_S4_p1q1[ 142] = SMALLER;
	map_S4_p1q1[ 146] = SMALLER;
	map_S4_p1q1[ 150] = SMALLER;
	map_S4_p1q1[ 154] = SMALLER;
	map_S4_p1q1[ 158] = SMALLER;
	map_S4_p1q1[ 166] = SMALLER;
	map_S4_p1q1[ 170] = SMALLER;
	map_S4_p1q1[ 178] = SMALLER;
	map_S4_p1q1[ 182] = SMALLER;
	map_S4_p1q1[ 194] = SMALLER;
	map_S4_p1q1[ 202] = SMALLER;
	map_S4_p1q1[ 210] = SMALLER;
	map_S4_p1q1[ 214] = SMALLER;
	map_S4_p1q1[ 218] = SMALLER;
	map_S4_p1q1[ 222] = SMALLER;
	map_S4_p1q1[ 226] = SMALLER;
	map_S4_p1q1[ 242] = SMALLER;
	map_S4_p1q1[ 246] = SMALLER;
	map_S4_p1q1[ 770] = SMALLER;
	map_S4_p1q1[ 778] = SMALLER;
	map_S4_p1q1[ 806] = SMALLER;
	map_S4_p1q1[ 810] = SMALLER;
	map_S4_p1q1[ 818] = SMALLER;
	map_S4_p1q1[ 822] = SMALLER;
	map_S4_p1q1[ 834] = SMALLER;
	map_S4_p1q1[ 842] = SMALLER;
	map_S4_p1q1[ 850] = SMALLER;
	map_S4_p1q1[ 854] = SMALLER;
	map_S4_p1q1[ 858] = SMALLER;
	map_S4_p1q1[ 862] = SMALLER;
	map_S4_p1q1[ 870] = SMALLER;
	map_S4_p1q1[ 874] = SMALLER;
	map_S4_p1q1[ 890] = SMALLER;
	map_S4_p1q1[ 894] = SMALLER;
	map_S4_p1q1[ 897] = SMALLER;
	map_S4_p1q1[ 901] = SMALLER;
	map_S4_p1q1[ 917] = SMALLER;
	map_S4_p1q1[ 921] = SMALLER;
	map_S4_p1q1[ 929] = SMALLER;
	map_S4_p1q1[ 933] = SMALLER;
	map_S4_p1q1[ 937] = SMALLER;
	map_S4_p1q1[ 941] = SMALLER;
	map_S4_p1q1[ 949] = SMALLER;
	map_S4_p1q1[ 957] = SMALLER;
	map_S4_p1q1[ 961] = SMALLER;
	map_S4_p1q1[ 965] = SMALLER;
	map_S4_p1q1[ 977] = SMALLER;
	map_S4_p1q1[ 993] = SMALLER;
	map_S4_p1q1[ 997] = SMALLER;
	map_S4_p1q1[1001] = SMALLER;
	map_S4_p1q1[1005] = SMALLER;
	map_S4_p1q1[1009] = SMALLER;
	map_S4_p1q1[1017] = SMALLER;

	map_S4_p1q1[   6] = LARGER;
	map_S4_p1q1[  14] = LARGER;
	map_S4_p1q1[  18] = LARGER;
	map_S4_p1q1[  22] = LARGER;
	map_S4_p1q1[  26] = LARGER;
	map_S4_p1q1[  30] = LARGER;
	map_S4_p1q1[  46] = LARGER;
	map_S4_p1q1[  58] = LARGER;
	map_S4_p1q1[  62] = LARGER;
	map_S4_p1q1[  66] = LARGER;
	map_S4_p1q1[  74] = LARGER;
	map_S4_p1q1[  82] = LARGER;
	map_S4_p1q1[  86] = LARGER;
	map_S4_p1q1[  90] = LARGER;
	map_S4_p1q1[  94] = LARGER;
	map_S4_p1q1[ 102] = LARGER;
	map_S4_p1q1[ 106] = LARGER;
	map_S4_p1q1[ 122] = LARGER;
	map_S4_p1q1[ 126] = LARGER;
	map_S4_p1q1[ 129] = LARGER;
	map_S4_p1q1[ 133] = LARGER;
	map_S4_p1q1[ 149] = LARGER;
	map_S4_p1q1[ 153] = LARGER;
	map_S4_p1q1[ 161] = LARGER;
	map_S4_p1q1[ 165] = LARGER;
	map_S4_p1q1[ 169] = LARGER;
	map_S4_p1q1[ 173] = LARGER;
	map_S4_p1q1[ 181] = LARGER;
	map_S4_p1q1[ 189] = LARGER;
	map_S4_p1q1[ 201] = LARGER;
	map_S4_p1q1[ 205] = LARGER;
	map_S4_p1q1[ 213] = LARGER;
	map_S4_p1q1[ 217] = LARGER;
	map_S4_p1q1[ 245] = LARGER;
	map_S4_p1q1[ 253] = LARGER;
	map_S4_p1q1[ 777] = LARGER;
	map_S4_p1q1[ 781] = LARGER;
	map_S4_p1q1[ 797] = LARGER;
	map_S4_p1q1[ 801] = LARGER;
	map_S4_p1q1[ 805] = LARGER;
	map_S4_p1q1[ 809] = LARGER;
	map_S4_p1q1[ 813] = LARGER;
	map_S4_p1q1[ 821] = LARGER;
	map_S4_p1q1[ 829] = LARGER;
	map_S4_p1q1[ 841] = LARGER;
	map_S4_p1q1[ 845] = LARGER;
	map_S4_p1q1[ 853] = LARGER;
	map_S4_p1q1[ 857] = LARGER;
	map_S4_p1q1[ 865] = LARGER;
	map_S4_p1q1[ 869] = LARGER;
	map_S4_p1q1[ 873] = LARGER;
	map_S4_p1q1[ 877] = LARGER;
	map_S4_p1q1[ 881] = LARGER;
	map_S4_p1q1[ 889] = LARGER;
	map_S4_p1q1[ 902] = LARGER;
	map_S4_p1q1[ 910] = LARGER;
	map_S4_p1q1[ 914] = LARGER;
	map_S4_p1q1[ 918] = LARGER;
	map_S4_p1q1[ 922] = LARGER;
	map_S4_p1q1[ 926] = LARGER;
	map_S4_p1q1[ 934] = LARGER;
	map_S4_p1q1[ 938] = LARGER;
	map_S4_p1q1[ 946] = LARGER;
	map_S4_p1q1[ 950] = LARGER;
	map_S4_p1q1[ 966] = LARGER;
	map_S4_p1q1[ 974] = LARGER;
	map_S4_p1q1[ 998] = LARGER;
	map_S4_p1q1[1002] = LARGER;
	map_S4_p1q1[1018] = LARGER;
	map_S4_p1q1[1022] = LARGER;

	map_S5       = MapResult(); 
	map_S5[ 265] = SMALLER;
	map_S5[ 269] = SMALLER;
	map_S5[ 285] = SMALLER;
	map_S5[ 289] = SMALLER;
	map_S5[ 293] = SMALLER;
	map_S5[ 297] = SMALLER;
	map_S5[ 301] = SMALLER;
	map_S5[ 309] = SMALLER;
	map_S5[ 317] = SMALLER;
	map_S5[ 329] = SMALLER;
	map_S5[ 333] = SMALLER;
	map_S5[ 341] = SMALLER;
	map_S5[ 345] = SMALLER;
	map_S5[ 353] = SMALLER;
	map_S5[ 357] = SMALLER;
	map_S5[ 361] = SMALLER;
	map_S5[ 365] = SMALLER;
	map_S5[ 369] = SMALLER;
	map_S5[ 377] = SMALLER;
	map_S5[ 385] = SMALLER;
	map_S5[ 389] = SMALLER;
	map_S5[ 405] = SMALLER;
	map_S5[ 409] = SMALLER;
	map_S5[ 417] = SMALLER;
	map_S5[ 421] = SMALLER;
	map_S5[ 425] = SMALLER;
	map_S5[ 429] = SMALLER;
	map_S5[ 437] = SMALLER;
	map_S5[ 445] = SMALLER;
	map_S5[ 449] = SMALLER;
	map_S5[ 453] = SMALLER;
	map_S5[ 465] = SMALLER;
	map_S5[ 481] = SMALLER;
	map_S5[ 485] = SMALLER;
	map_S5[ 489] = SMALLER;
	map_S5[ 493] = SMALLER;
	map_S5[ 497] = SMALLER;
	map_S5[ 505] = SMALLER;
	map_S5[ 518] = SMALLER;
	map_S5[ 526] = SMALLER;
	map_S5[ 530] = SMALLER;
	map_S5[ 534] = SMALLER;
	map_S5[ 538] = SMALLER;
	map_S5[ 542] = SMALLER;
	map_S5[ 558] = SMALLER;
	map_S5[ 570] = SMALLER;
	map_S5[ 574] = SMALLER;
	map_S5[ 578] = SMALLER;
	map_S5[ 586] = SMALLER;
	map_S5[ 594] = SMALLER;
	map_S5[ 598] = SMALLER;
	map_S5[ 602] = SMALLER;
	map_S5[ 606] = SMALLER;
	map_S5[ 614] = SMALLER;
	map_S5[ 618] = SMALLER;
	map_S5[ 634] = SMALLER;
	map_S5[ 638] = SMALLER;
	map_S5[ 646] = SMALLER;
	map_S5[ 654] = SMALLER;
	map_S5[ 658] = SMALLER;
	map_S5[ 662] = SMALLER;
	map_S5[ 666] = SMALLER;
	map_S5[ 670] = SMALLER;
	map_S5[ 678] = SMALLER;
	map_S5[ 682] = SMALLER;
	map_S5[ 690] = SMALLER;
	map_S5[ 694] = SMALLER;
	map_S5[ 706] = SMALLER;
	map_S5[ 714] = SMALLER;
	map_S5[ 722] = SMALLER;
	map_S5[ 726] = SMALLER;
	map_S5[ 730] = SMALLER;
	map_S5[ 734] = SMALLER;
	map_S5[ 738] = SMALLER;
	map_S5[ 754] = SMALLER;
	map_S5[ 758] = SMALLER;
	map_S5[1282] = SMALLER;
	map_S5[1290] = SMALLER;
	map_S5[1318] = SMALLER;
	map_S5[1322] = SMALLER;
	map_S5[1330] = SMALLER;
	map_S5[1334] = SMALLER;
	map_S5[1346] = SMALLER;
	map_S5[1354] = SMALLER;
	map_S5[1362] = SMALLER;
	map_S5[1366] = SMALLER;
	map_S5[1370] = SMALLER;
	map_S5[1374] = SMALLER;
	map_S5[1382] = SMALLER;
	map_S5[1386] = SMALLER;
	map_S5[1402] = SMALLER;
	map_S5[1406] = SMALLER;
	map_S5[1414] = SMALLER;
	map_S5[1422] = SMALLER;
	map_S5[1426] = SMALLER;
	map_S5[1430] = SMALLER;
	map_S5[1434] = SMALLER;
	map_S5[1438] = SMALLER;
	map_S5[1446] = SMALLER;
	map_S5[1450] = SMALLER;
	map_S5[1458] = SMALLER;
	map_S5[1462] = SMALLER;
	map_S5[1478] = SMALLER;
	map_S5[1486] = SMALLER;
	map_S5[1510] = SMALLER;
	map_S5[1514] = SMALLER;
	map_S5[1530] = SMALLER;
	map_S5[1534] = SMALLER;
	map_S5[1537] = SMALLER;
	map_S5[1541] = SMALLER;
	map_S5[1557] = SMALLER;
	map_S5[1561] = SMALLER;
	map_S5[1585] = SMALLER;
	map_S5[1593] = SMALLER;
	map_S5[1609] = SMALLER;
	map_S5[1613] = SMALLER;
	map_S5[1621] = SMALLER;
	map_S5[1625] = SMALLER;
	map_S5[1633] = SMALLER;
	map_S5[1637] = SMALLER;
	map_S5[1641] = SMALLER;
	map_S5[1645] = SMALLER;
	map_S5[1649] = SMALLER;
	map_S5[1657] = SMALLER;
	map_S5[1665] = SMALLER;
	map_S5[1669] = SMALLER;
	map_S5[1685] = SMALLER;
	map_S5[1689] = SMALLER;
	map_S5[1697] = SMALLER;
	map_S5[1701] = SMALLER;
	map_S5[1705] = SMALLER;
	map_S5[1709] = SMALLER;
	map_S5[1717] = SMALLER;
	map_S5[1725] = SMALLER;
	map_S5[1737] = SMALLER;
	map_S5[1741] = SMALLER;
	map_S5[1749] = SMALLER;
	map_S5[1753] = SMALLER;
	map_S5[1781] = SMALLER;
	map_S5[1789] = SMALLER;

	map_S5[ 258] = LARGER;
	map_S5[ 266] = LARGER;
	map_S5[ 294] = LARGER;
	map_S5[ 298] = LARGER;
	map_S5[ 306] = LARGER;
	map_S5[ 310] = LARGER;
	map_S5[ 322] = LARGER;
	map_S5[ 330] = LARGER;
	map_S5[ 338] = LARGER;
	map_S5[ 342] = LARGER;
	map_S5[ 346] = LARGER;
	map_S5[ 350] = LARGER;
	map_S5[ 358] = LARGER;
	map_S5[ 362] = LARGER;
	map_S5[ 378] = LARGER;
	map_S5[ 382] = LARGER;
	map_S5[ 390] = LARGER;
	map_S5[ 398] = LARGER;
	map_S5[ 402] = LARGER;
	map_S5[ 406] = LARGER;
	map_S5[ 410] = LARGER;
	map_S5[ 414] = LARGER;
	map_S5[ 422] = LARGER;
	map_S5[ 426] = LARGER;
	map_S5[ 434] = LARGER;
	map_S5[ 438] = LARGER;
	map_S5[ 454] = LARGER;
	map_S5[ 462] = LARGER;
	map_S5[ 486] = LARGER;
	map_S5[ 490] = LARGER;
	map_S5[ 506] = LARGER;
	map_S5[ 510] = LARGER;
	map_S5[ 513] = LARGER;
	map_S5[ 517] = LARGER;
	map_S5[ 533] = LARGER;
	map_S5[ 537] = LARGER;
	map_S5[ 561] = LARGER;
	map_S5[ 569] = LARGER;
	map_S5[ 585] = LARGER;
	map_S5[ 589] = LARGER;
	map_S5[ 597] = LARGER;
	map_S5[ 601] = LARGER;
	map_S5[ 609] = LARGER;
	map_S5[ 613] = LARGER;
	map_S5[ 617] = LARGER;
	map_S5[ 621] = LARGER;
	map_S5[ 625] = LARGER;
	map_S5[ 633] = LARGER;
	map_S5[ 641] = LARGER;
	map_S5[ 645] = LARGER;
	map_S5[ 661] = LARGER;
	map_S5[ 665] = LARGER;
	map_S5[ 673] = LARGER;
	map_S5[ 677] = LARGER;
	map_S5[ 681] = LARGER;
	map_S5[ 685] = LARGER;
	map_S5[ 693] = LARGER;
	map_S5[ 701] = LARGER;
	map_S5[ 713] = LARGER;
	map_S5[ 717] = LARGER;
	map_S5[ 725] = LARGER;
	map_S5[ 729] = LARGER;
	map_S5[ 757] = LARGER;
	map_S5[ 765] = LARGER;
	map_S5[1289] = LARGER;
	map_S5[1293] = LARGER;
	map_S5[1309] = LARGER;
	map_S5[1313] = LARGER;
	map_S5[1317] = LARGER;
	map_S5[1321] = LARGER;
	map_S5[1325] = LARGER;
	map_S5[1333] = LARGER;
	map_S5[1341] = LARGER;
	map_S5[1353] = LARGER;
	map_S5[1357] = LARGER;
	map_S5[1365] = LARGER;
	map_S5[1369] = LARGER;
	map_S5[1377] = LARGER;
	map_S5[1381] = LARGER;
	map_S5[1385] = LARGER;
	map_S5[1389] = LARGER;
	map_S5[1393] = LARGER;
	map_S5[1401] = LARGER;
	map_S5[1409] = LARGER;
	map_S5[1413] = LARGER;
	map_S5[1429] = LARGER;
	map_S5[1433] = LARGER;
	map_S5[1441] = LARGER;
	map_S5[1445] = LARGER;
	map_S5[1449] = LARGER;
	map_S5[1453] = LARGER;
	map_S5[1461] = LARGER;
	map_S5[1469] = LARGER;
	map_S5[1473] = LARGER;
	map_S5[1477] = LARGER;
	map_S5[1489] = LARGER;
	map_S5[1505] = LARGER;
	map_S5[1509] = LARGER;
	map_S5[1513] = LARGER;
	map_S5[1517] = LARGER;
	map_S5[1521] = LARGER;
	map_S5[1529] = LARGER;
	map_S5[1542] = LARGER;
	map_S5[1550] = LARGER;
	map_S5[1554] = LARGER;
	map_S5[1558] = LARGER;
	map_S5[1562] = LARGER;
	map_S5[1566] = LARGER;
	map_S5[1582] = LARGER;
	map_S5[1594] = LARGER;
	map_S5[1598] = LARGER;
	map_S5[1602] = LARGER;
	map_S5[1610] = LARGER;
	map_S5[1618] = LARGER;
	map_S5[1622] = LARGER;
	map_S5[1626] = LARGER;
	map_S5[1630] = LARGER;
	map_S5[1638] = LARGER;
	map_S5[1642] = LARGER;
	map_S5[1658] = LARGER;
	map_S5[1662] = LARGER;
	map_S5[1670] = LARGER;
	map_S5[1678] = LARGER;
	map_S5[1682] = LARGER;
	map_S5[1686] = LARGER;
	map_S5[1690] = LARGER;
	map_S5[1694] = LARGER;
	map_S5[1702] = LARGER;
	map_S5[1706] = LARGER;
	map_S5[1714] = LARGER;
	map_S5[1718] = LARGER;
	map_S5[1730] = LARGER;
	map_S5[1738] = LARGER;
	map_S5[1746] = LARGER;
	map_S5[1750] = LARGER;
	map_S5[1754] = LARGER;
	map_S5[1758] = LARGER;
	map_S5[1762] = LARGER;
	map_S5[1778] = LARGER;
	map_S5[1782] = LARGER;
}


__ALGEBRAIC_END_NAMESPACE
