#include <iostream>
#include <synaps/arithm/gmp.h>
#include <synaps/usolve/Algebraic.h>

using std::cout;
using std::cin;
using std::endl;

typedef ZZ NT;
typedef Algebraic<ZZ> SOLVER;

typedef SOLVER::RT         RT;
typedef SOLVER::FT         FT;

typedef SOLVER::Poly       Poly;

typedef SOLVER::RO_t       RO_t;




typedef ZZ RT;
typedef UPolDse<ZZ> UPoly;

int main()
{
  Poly f1(4, AsSize());
  f1[3] = 1;
  f1[2] = 2;
  f1[1] = -65;
  f1[0] = 150;

  std::cout <<f1<<std::endl;
  RO_t r1 = solve(f1, SOLVER(), 1);
  std::cout << "here\n";
  
  cout << "r1 = " << to_double( r1) << endl;

  Poly f2(3, AsSize());
  f2[2] = 5;
  f2[1] = -4;
  f2[0] = -9;
  
  RO_t r2 = solve(f2, SOLVER(), 0);
  cout << "r2 = " << r2 << endl;

  int result = ALGEBRAIC::compare(r1, r2);
  cout << "Result = " << result << endl;
  if (result == 1)
    cout << r1 << " > " << r2 << endl;
  else if (result == -1)
    cout << r1 << " < " << r2 << endl;
  else
    cout << r1 << " = " << r2 << endl;

  return 0;

}


