#define USING_NAMESPACE_SYNAPS 1

#include "synaps/bignum.h"
#include "synaps/upol.h"
#include "synaps/usolve/Aberth.h"


using std::cin;
using std::cout;
using std::endl;

#ifdef SYNAPS_WITH_GMP
typedef UPolDse<ZZ> Upol;
#endif //SYNAPS_WITH_GMP

int main (int argc,char**argv)
{
#ifdef SYNAPS_WITH_GMP
  using namespace std;
  Upol p("x0^31-x0^17+1");

#ifdef SYNAPS_WITH_GMP
  Seq<CC> r =solve(p, SlvAberth<CC>());
  cout<<"Roots:"<<endl;
  for (int i = 0; i < degree(p); i++) cout<<"#"<<i+1<<": "<<r[i]<<endl;

  Seq<RR> rr = solve(p,SlvAberth<RR>());
  cout<<"Real Roots:"<<endl;
  for (unsigned i = 0; i < rr.size(); i++) cout<<"#"<<i+1<<": "<<rr[i]<<endl;
#else
  cout <<"mpsolve not connected"<<endl;
  return (77);
#endif //SYNAPS_WITH_GMP

  return 0;
#else 
  std::cout <<"  Gmp is not connected"<<std::endl;
  return(77);
#endif //SYNAPS_WITH_GMP
}
 
